/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * API Management service resource SKU properties.
 *
 */
class ApiManagementServiceSkuProperties {
  /**
   * Create a ApiManagementServiceSkuProperties.
   * @property {string} name Name of the Sku. Possible values include:
   * 'Developer', 'Standard', 'Premium', 'Basic', 'Consumption'
   * @property {number} capacity Capacity of the SKU (number of deployed units
   * of the SKU). For Consumption SKU capacity must be specified as 0.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiManagementServiceSkuProperties
   *
   * @returns {object} metadata of ApiManagementServiceSkuProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiManagementServiceSkuProperties',
      type: {
        name: 'Composite',
        className: 'ApiManagementServiceSkuProperties',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          capacity: {
            required: true,
            serializedName: 'capacity',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiManagementServiceSkuProperties;
