/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Control Plane Apis version constraint for the API Management service.
 *
 */
class ApiVersionConstraint {
  /**
   * Create a ApiVersionConstraint.
   * @property {string} [minApiVersion] Limit control plane API calls to API
   * Management service with version equal to or newer than this value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiVersionConstraint
   *
   * @returns {object} metadata of ApiVersionConstraint
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiVersionConstraint',
      type: {
        name: 'Composite',
        className: 'ApiVersionConstraint',
        modelProperties: {
          minApiVersion: {
            required: false,
            serializedName: 'minApiVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiVersionConstraint;
