/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Cache update details.
 *
 */
class CacheUpdateParameters {
  /**
   * Create a CacheUpdateParameters.
   * @property {string} [description] Cache description
   * @property {string} [connectionString] Runtime connection string to cache
   * @property {string} [resourceId] Original uri of entity in external system
   * cache points to
   */
  constructor() {
  }

  /**
   * Defines the metadata of CacheUpdateParameters
   *
   * @returns {object} metadata of CacheUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CacheUpdateParameters',
      type: {
        name: 'Composite',
        className: 'CacheUpdateParameters',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'properties.description',
            constraints: {
              MaxLength: 2000
            },
            type: {
              name: 'String'
            }
          },
          connectionString: {
            required: false,
            serializedName: 'properties.connectionString',
            constraints: {
              MaxLength: 300
            },
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            serializedName: 'properties.resourceId',
            constraints: {
              MaxLength: 2000
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CacheUpdateParameters;
