/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Group contract Properties.
 *
 */
class GroupContractProperties {
  /**
   * Create a GroupContractProperties.
   * @property {string} displayName Group name.
   * @property {string} [description] Group description. Can contain HTML
   * formatting tags.
   * @property {boolean} [builtIn] true if the group is one of the three system
   * groups (Administrators, Developers, or Guests); otherwise false.
   * @property {string} [type] Group type. Possible values include: 'custom',
   * 'system', 'external'
   * @property {string} [externalId] For external groups, this property
   * contains the id of the group from the external identity provider, e.g. for
   * Azure Active Directory `aad://<tenant>.onmicrosoft.com/groups/<group
   * object id>`; otherwise the value is null.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GroupContractProperties
   *
   * @returns {object} metadata of GroupContractProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GroupContractProperties',
      type: {
        name: 'Composite',
        className: 'GroupContractProperties',
        modelProperties: {
          displayName: {
            required: true,
            serializedName: 'displayName',
            constraints: {
              MaxLength: 300,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            constraints: {
              MaxLength: 1000
            },
            type: {
              name: 'String'
            }
          },
          builtIn: {
            required: false,
            readOnly: true,
            serializedName: 'builtIn',
            type: {
              name: 'Boolean'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'custom', 'system', 'external' ]
            }
          },
          externalId: {
            required: false,
            serializedName: 'externalId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GroupContractProperties;
