/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Network Status in the Location
 *
 */
class NetworkStatusContractByLocation {
  /**
   * Create a NetworkStatusContractByLocation.
   * @property {string} [location] Location of service
   * @property {object} [networkStatus] Network status in Location
   * @property {array} [networkStatus.dnsServers] Gets the list of DNS servers
   * IPV4 addresses.
   * @property {array} [networkStatus.connectivityStatus] Gets the list of
   * Connectivity Status to the Resources on which the service depends upon.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkStatusContractByLocation
   *
   * @returns {object} metadata of NetworkStatusContractByLocation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkStatusContractByLocation',
      type: {
        name: 'Composite',
        className: 'NetworkStatusContractByLocation',
        modelProperties: {
          location: {
            required: false,
            serializedName: 'location',
            constraints: {
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          networkStatus: {
            required: false,
            serializedName: 'networkStatus',
            type: {
              name: 'Composite',
              className: 'NetworkStatusContract'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkStatusContractByLocation;
