/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Notification details.
 *
 * @extends models['Resource']
 */
class NotificationContract extends models['Resource'] {
  /**
   * Create a NotificationContract.
   * @property {string} title Title of the Notification.
   * @property {string} [description] Description of the Notification.
   * @property {object} [recipients] Recipient Parameter values.
   * @property {array} [recipients.emails] List of Emails subscribed for the
   * notification.
   * @property {array} [recipients.users] List of Users subscribed for the
   * notification.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of NotificationContract
   *
   * @returns {object} metadata of NotificationContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NotificationContract',
      type: {
        name: 'Composite',
        className: 'NotificationContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          title: {
            required: true,
            serializedName: 'properties.title',
            constraints: {
              MaxLength: 1000,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          recipients: {
            required: false,
            serializedName: 'properties.recipients',
            type: {
              name: 'Composite',
              className: 'RecipientsContractProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = NotificationContract;
