/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Policy Contract details.
 *
 * @extends models['Resource']
 */
class PolicyContract extends models['Resource'] {
  /**
   * Create a PolicyContract.
   * @property {string} value Contents of the Policy as defined by the format.
   * @property {string} [format] Format of the policyContent. Possible values
   * include: 'xml', 'xml-link', 'rawxml', 'rawxml-link'. Default value: 'xml'
   * .
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PolicyContract
   *
   * @returns {object} metadata of PolicyContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PolicyContract',
      type: {
        name: 'Composite',
        className: 'PolicyContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'properties.value',
            type: {
              name: 'String'
            }
          },
          format: {
            required: false,
            serializedName: 'properties.format',
            defaultValue: 'xml',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PolicyContract;
