/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Resource location data properties.
 *
 */
class ResourceLocationDataContract {
  /**
   * Create a ResourceLocationDataContract.
   * @property {string} name A canonical name for the geographic or physical
   * location.
   * @property {string} [city] The city or locality where the resource is
   * located.
   * @property {string} [district] The district, state, or province where the
   * resource is located.
   * @property {string} [countryOrRegion] The country or region where the
   * resource is located.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceLocationDataContract
   *
   * @returns {object} metadata of ResourceLocationDataContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceLocationDataContract',
      type: {
        name: 'Composite',
        className: 'ResourceLocationDataContract',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            constraints: {
              MaxLength: 256
            },
            type: {
              name: 'String'
            }
          },
          city: {
            required: false,
            serializedName: 'city',
            constraints: {
              MaxLength: 256
            },
            type: {
              name: 'String'
            }
          },
          district: {
            required: false,
            serializedName: 'district',
            constraints: {
              MaxLength: 256
            },
            type: {
              name: 'String'
            }
          },
          countryOrRegion: {
            required: false,
            serializedName: 'countryOrRegion',
            constraints: {
              MaxLength: 256
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceLocationDataContract;
