/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Save Tenant Configuration Contract details.
 *
 */
class SaveConfigurationParameter {
  /**
   * Create a SaveConfigurationParameter.
   * @property {string} branch The name of the Git branch in which to commit
   * the current configuration snapshot.
   * @property {boolean} [force] The value if true, the current configuration
   * database is committed to the Git repository, even if the Git repository
   * has newer changes that would be overwritten.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SaveConfigurationParameter
   *
   * @returns {object} metadata of SaveConfigurationParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SaveConfigurationParameter',
      type: {
        name: 'Composite',
        className: 'SaveConfigurationParameter',
        modelProperties: {
          branch: {
            required: true,
            serializedName: 'properties.branch',
            type: {
              name: 'String'
            }
          },
          force: {
            required: false,
            serializedName: 'properties.force',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = SaveConfigurationParameter;
