/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Tag Contract details.
 *
 * @extends models['Resource']
 */
class TagContract extends models['Resource'] {
  /**
   * Create a TagContract.
   * @property {string} displayName Tag name.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TagContract
   *
   * @returns {object} metadata of TagContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TagContract',
      type: {
        name: 'Composite',
        className: 'TagContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: true,
            serializedName: 'properties.displayName',
            constraints: {
              MaxLength: 160,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TagContract;
