/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Error details.
  *
 * Contains details when the response code indicates an error.
 *
 */
class ErrorResponse {
  /**
   * Create a ErrorResponse.
   * @member {object} error The error details.
   * @member {string} [error.code] A machine readable error code.
   * @member {string} [error.message] A human readable error message.
   * @member {array} [error.details] error details.
   * @member {object} [error.innererror] Inner error details if they exist.
   * @member {object} [error.additionalProperties]
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorResponse
   *
   * @returns {object} metadata of ErrorResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'errorResponse',
      type: {
        name: 'Composite',
        className: 'ErrorResponse',
        modelProperties: {
          error: {
            required: true,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ErrorInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorResponse;
