/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The browser timing information
 *
 */
class EventsBrowserTimingInfo {
  /**
   * Create a EventsBrowserTimingInfo.
   * @member {string} [urlPath] The path of the URL
   * @member {string} [urlHost] The host of the URL
   * @member {string} [name] The name of the page
   * @member {string} [url] The url of the page
   * @member {number} [totalDuration] The total duration of the load
   * @member {string} [performanceBucket] The performance bucket of the load
   * @member {number} [networkDuration] The network duration of the load
   * @member {number} [sendDuration] The send duration of the load
   * @member {number} [receiveDuration] The receive duration of the load
   * @member {number} [processingDuration] The processing duration of the load
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventsBrowserTimingInfo
   *
   * @returns {object} metadata of EventsBrowserTimingInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'eventsBrowserTimingInfo',
      type: {
        name: 'Composite',
        className: 'EventsBrowserTimingInfo',
        modelProperties: {
          urlPath: {
            required: false,
            serializedName: 'urlPath',
            type: {
              name: 'String'
            }
          },
          urlHost: {
            required: false,
            serializedName: 'urlHost',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          totalDuration: {
            required: false,
            serializedName: 'totalDuration',
            type: {
              name: 'Number'
            }
          },
          performanceBucket: {
            required: false,
            serializedName: 'performanceBucket',
            type: {
              name: 'String'
            }
          },
          networkDuration: {
            required: false,
            serializedName: 'networkDuration',
            type: {
              name: 'Number'
            }
          },
          sendDuration: {
            required: false,
            serializedName: 'sendDuration',
            type: {
              name: 'Number'
            }
          },
          receiveDuration: {
            required: false,
            serializedName: 'receiveDuration',
            type: {
              name: 'Number'
            }
          },
          processingDuration: {
            required: false,
            serializedName: 'processingDuration',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsBrowserTimingInfo;
