/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The custom metric info
 *
 */
class EventsCustomMetricInfo {
  /**
   * Create a EventsCustomMetricInfo.
   * @member {string} [name] The name of the custom metric
   * @member {number} [value] The value of the custom metric
   * @member {number} [valueSum] The sum of the custom metric
   * @member {number} [valueCount] The count of the custom metric
   * @member {number} [valueMin] The minimum value of the custom metric
   * @member {number} [valueMax] The maximum value of the custom metric
   * @member {number} [valueStdDev] The standard deviation of the custom metric
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventsCustomMetricInfo
   *
   * @returns {object} metadata of EventsCustomMetricInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'eventsCustomMetricInfo',
      type: {
        name: 'Composite',
        className: 'EventsCustomMetricInfo',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Number'
            }
          },
          valueSum: {
            required: false,
            serializedName: 'valueSum',
            type: {
              name: 'Number'
            }
          },
          valueCount: {
            required: false,
            serializedName: 'valueCount',
            type: {
              name: 'Number'
            }
          },
          valueMin: {
            required: false,
            serializedName: 'valueMin',
            type: {
              name: 'Number'
            }
          },
          valueMax: {
            required: false,
            serializedName: 'valueMax',
            type: {
              name: 'Number'
            }
          },
          valueStdDev: {
            required: false,
            serializedName: 'valueStdDev',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsCustomMetricInfo;
