/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A custom metric result
 *
 * @extends models['EventsResultData']
 */
class EventsCustomMetricResult extends models['EventsResultData'] {
  /**
   * Create a EventsCustomMetricResult.
   * @member {object} [customMetric]
   * @member {string} [customMetric.name] The name of the custom metric
   * @member {number} [customMetric.value] The value of the custom metric
   * @member {number} [customMetric.valueSum] The sum of the custom metric
   * @member {number} [customMetric.valueCount] The count of the custom metric
   * @member {number} [customMetric.valueMin] The minimum value of the custom
   * metric
   * @member {number} [customMetric.valueMax] The maximum value of the custom
   * metric
   * @member {number} [customMetric.valueStdDev] The standard deviation of the
   * custom metric
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EventsCustomMetricResult
   *
   * @returns {object} metadata of EventsCustomMetricResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'customMetric',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'EventsResultData',
        className: 'EventsCustomMetricResult',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          count: {
            required: false,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          timestamp: {
            required: false,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          },
          customDimensions: {
            required: false,
            serializedName: 'customDimensions',
            type: {
              name: 'Composite',
              className: 'EventsResultDataCustomDimensions'
            }
          },
          customMeasurements: {
            required: false,
            serializedName: 'customMeasurements',
            type: {
              name: 'Composite',
              className: 'EventsResultDataCustomMeasurements'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'Composite',
              className: 'EventsOperationInfo'
            }
          },
          session: {
            required: false,
            serializedName: 'session',
            type: {
              name: 'Composite',
              className: 'EventsSessionInfo'
            }
          },
          user: {
            required: false,
            serializedName: 'user',
            type: {
              name: 'Composite',
              className: 'EventsUserInfo'
            }
          },
          cloud: {
            required: false,
            serializedName: 'cloud',
            type: {
              name: 'Composite',
              className: 'EventsCloudInfo'
            }
          },
          ai: {
            required: false,
            serializedName: 'ai',
            type: {
              name: 'Composite',
              className: 'EventsAiInfo'
            }
          },
          application: {
            required: false,
            serializedName: 'application',
            type: {
              name: 'Composite',
              className: 'EventsApplicationInfo'
            }
          },
          client: {
            required: false,
            serializedName: 'client',
            type: {
              name: 'Composite',
              className: 'EventsClientInfo'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          customMetric: {
            required: false,
            serializedName: 'customMetric',
            type: {
              name: 'Composite',
              className: 'EventsCustomMetricInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsCustomMetricResult;
