/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains a sourceId and workbook resource id to link two resources.
 *
 */
class LinkProperties {
  /**
   * Create a LinkProperties.
   * @member {string} [sourceId] The source Azure resource id
   * @member {string} [targetId] The workbook Azure resource id
   * @member {string} [category] The category of workbook
   */
  constructor() {
  }

  /**
   * Defines the metadata of LinkProperties
   *
   * @returns {object} metadata of LinkProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LinkProperties',
      type: {
        name: 'Composite',
        className: 'LinkProperties',
        modelProperties: {
          sourceId: {
            required: false,
            serializedName: 'sourceId',
            type: {
              name: 'String'
            }
          },
          targetId: {
            required: false,
            serializedName: 'targetId',
            type: {
              name: 'String'
            }
          },
          category: {
            required: false,
            serializedName: 'category',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LinkProperties;
