/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters supplied to the create or update node configuration
 * operation.
 *
 */
class DscNodeConfigurationCreateOrUpdateParametersProperties {
  /**
   * Create a DscNodeConfigurationCreateOrUpdateParametersProperties.
   * @member {object} source Gets or sets the source.
   * @member {object} [source.hash] Gets or sets the hash.
   * @member {string} [source.hash.algorithm] Gets or sets the content hash
   * algorithm used to hash the content.
   * @member {string} [source.hash.value] Gets or sets expected hash value of
   * the content.
   * @member {string} [source.type] Gets or sets the content source type.
   * Possible values include: 'embeddedContent', 'uri'
   * @member {string} [source.value] Gets or sets the value of the content.
   * This is based on the content source type.
   * @member {string} [source.version] Gets or sets the version of the content.
   * @member {string} name Gets or sets the type of the parameter.
   * @member {object} configuration Gets or sets the configuration of the node.
   * @member {string} [configuration.name] Gets or sets the name of the Dsc
   * configuration.
   * @member {boolean} [incrementNodeConfigurationBuild] If a new build version
   * of NodeConfiguration is required.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DscNodeConfigurationCreateOrUpdateParametersProperties
   *
   * @returns {object} metadata of DscNodeConfigurationCreateOrUpdateParametersProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DscNodeConfigurationCreateOrUpdateParametersProperties',
      type: {
        name: 'Composite',
        className: 'DscNodeConfigurationCreateOrUpdateParametersProperties',
        modelProperties: {
          source: {
            required: true,
            serializedName: 'source',
            type: {
              name: 'Composite',
              className: 'ContentSource'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          configuration: {
            required: true,
            serializedName: 'configuration',
            type: {
              name: 'Composite',
              className: 'DscConfigurationAssociationProperty'
            }
          },
          incrementNodeConfigurationBuild: {
            required: false,
            serializedName: 'incrementNodeConfigurationBuild',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = DscNodeConfigurationCreateOrUpdateParametersProperties;
