/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Software update configuration machine run model.
 *
 */
class SoftwareUpdateConfigurationMachineRun {
  /**
   * Create a SoftwareUpdateConfigurationMachineRun.
   * @member {string} [name] Name of the software update configuration machine
   * run
   * @member {string} [id] Resource Id of the software update configuration
   * machine run
   * @member {string} [targetComputer] name of the updated computer
   * @member {string} [targetComputerType] type of the updated computer.
   * @member {object} [softwareUpdateConfiguration] software update
   * configuration triggered this run
   * @member {string} [softwareUpdateConfiguration.name] Name of the software
   * update configuration triggered the software update configuration run
   * @member {string} [status] Status of the software update configuration
   * machine run.
   * @member {string} [osType] Operating system target of the software update
   * configuration triggered this run
   * @member {uuid} [correlationId] correlation id of the software update
   * configuration machine run
   * @member {uuid} [sourceComputerId] source computer id of the software
   * update configuration machine run
   * @member {date} [startTime] Start time of the software update configuration
   * machine run.
   * @member {date} [endTime] End time of the software update configuration
   * machine run.
   * @member {string} [configuredDuration] configured duration for the software
   * update configuration run.
   * @member {object} [job] Job associated with the software update
   * configuration machine run
   * @member {string} [job.id] Id of the job associated with the software
   * update configuration run
   * @member {date} [creationTime] Creation time of theresource, which only
   * appears in the response.
   * @member {string} [createdBy] createdBy property, which only appears in the
   * response.
   * @member {date} [lastModifiedTime] Last time resource was modified, which
   * only appears in the response.
   * @member {string} [lastModifiedBy] lastModifiedBy property, which only
   * appears in the response.
   * @member {object} [error] detailes of provisioning error
   * @member {string} [error.code] Error code
   * @member {string} [error.message] Error message indicating why the
   * operation failed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SoftwareUpdateConfigurationMachineRun
   *
   * @returns {object} metadata of SoftwareUpdateConfigurationMachineRun
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'softwareUpdateConfigurationMachineRun',
      type: {
        name: 'Composite',
        className: 'SoftwareUpdateConfigurationMachineRun',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          targetComputer: {
            required: false,
            readOnly: true,
            serializedName: 'properties.targetComputer',
            type: {
              name: 'String'
            }
          },
          targetComputerType: {
            required: false,
            readOnly: true,
            serializedName: 'properties.targetComputerType',
            type: {
              name: 'String'
            }
          },
          softwareUpdateConfiguration: {
            required: false,
            serializedName: 'properties.softwareUpdateConfiguration',
            type: {
              name: 'Composite',
              className: 'UpdateConfigurationNavigation'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'properties.status',
            type: {
              name: 'String'
            }
          },
          osType: {
            required: false,
            readOnly: true,
            serializedName: 'properties.osType',
            type: {
              name: 'String'
            }
          },
          correlationId: {
            required: false,
            readOnly: true,
            serializedName: 'properties.correlationId',
            type: {
              name: 'String'
            }
          },
          sourceComputerId: {
            required: false,
            readOnly: true,
            serializedName: 'properties.sourceComputerId',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'properties.startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'properties.endTime',
            type: {
              name: 'DateTime'
            }
          },
          configuredDuration: {
            required: false,
            readOnly: true,
            serializedName: 'properties.configuredDuration',
            type: {
              name: 'String'
            }
          },
          job: {
            required: false,
            serializedName: 'properties.job',
            type: {
              name: 'Composite',
              className: 'JobNavigation'
            }
          },
          creationTime: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'properties.creationTime',
            type: {
              name: 'DateTime'
            }
          },
          createdBy: {
            required: false,
            readOnly: true,
            serializedName: 'properties.createdBy',
            type: {
              name: 'String'
            }
          },
          lastModifiedTime: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'properties.lastModifiedTime',
            type: {
              name: 'DateTime'
            }
          },
          lastModifiedBy: {
            required: false,
            readOnly: true,
            serializedName: 'properties.lastModifiedBy',
            type: {
              name: 'String'
            }
          },
          error: {
            required: false,
            serializedName: 'properties.error',
            type: {
              name: 'Composite',
              className: 'ErrorResponse'
            }
          }
        }
      }
    };
  }
}

module.exports = SoftwareUpdateConfigurationMachineRun;
