/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Definition of the source control sync job.
 *
 */
class SourceControlSyncJobById {
  /**
   * Create a SourceControlSyncJobById.
   * @member {string} [id] The id of the job.
   * @member {string} [sourceControlSyncJobId] The source control sync job id.
   * @member {date} [creationTime] The creation time of the job.
   * @member {string} [provisioningState] The provisioning state of the job.
   * Possible values include: 'Completed', 'Failed', 'Running'
   * @member {date} [startTime] The start time of the job.
   * @member {date} [endTime] The end time of the job.
   * @member {string} [syncType] The sync type. Possible values include:
   * 'PartialSync', 'FullSync'
   * @member {string} [exception] The exceptions that occured while running the
   * sync job.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SourceControlSyncJobById
   *
   * @returns {object} metadata of SourceControlSyncJobById
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SourceControlSyncJobById',
      type: {
        name: 'Composite',
        className: 'SourceControlSyncJobById',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          sourceControlSyncJobId: {
            required: false,
            serializedName: 'properties.sourceControlSyncJobId',
            type: {
              name: 'String'
            }
          },
          creationTime: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'properties.creationTime',
            type: {
              name: 'DateTime'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'properties.startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'properties.endTime',
            type: {
              name: 'DateTime'
            }
          },
          syncType: {
            required: false,
            serializedName: 'properties.syncType',
            type: {
              name: 'String'
            }
          },
          exception: {
            required: false,
            serializedName: 'properties.exception',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SourceControlSyncJobById;
