/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Registration resource
 *
 * @extends models['Resource']
 */
class RegistrationParameter extends models['Resource'] {
  /**
   * Create a RegistrationParameter.
   * @member {string} registrationToken The token identifying registered Azure
   * Stack
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RegistrationParameter
   *
   * @returns {object} metadata of RegistrationParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegistrationParameter',
      type: {
        name: 'Composite',
        className: 'RegistrationParameter',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            isConstant: true,
            serializedName: 'location',
            defaultValue: 'global',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          registrationToken: {
            required: true,
            serializedName: 'properties.registrationToken',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RegistrationParameter;
