/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Product information.
 *
 */
class VirtualMachineProductProperties {
  /**
   * Create a VirtualMachineProductProperties.
   * @member {string} [version] Specifies product version.
   * @member {object} [osDiskImage] OS disk image used by product.
   * @member {string} [osDiskImage.operatingSystem] OS operating system type.
   * Possible values include: 'None', 'Windows', 'Linux'
   * @member {string} [osDiskImage.sourceBlobSasUri] SAS key for source blob.
   * @member {array} [dataDiskImages] List of attached data disks.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineProductProperties
   *
   * @returns {object} metadata of VirtualMachineProductProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineProductProperties',
      type: {
        name: 'Composite',
        className: 'VirtualMachineProductProperties',
        modelProperties: {
          version: {
            required: false,
            readOnly: true,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          },
          osDiskImage: {
            required: false,
            readOnly: true,
            serializedName: 'osDiskImage',
            type: {
              name: 'Composite',
              className: 'OsDiskImage'
            }
          },
          dataDiskImages: {
            required: false,
            readOnly: true,
            serializedName: 'dataDiskImages',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DataDiskImageElementType',
                  type: {
                    name: 'Composite',
                    className: 'DataDiskImage'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineProductProperties;
