/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Information about the Compute Node on which a Task ran.
  *
 */
class ComputeNodeInformation {
  /**
   * Create a ComputeNodeInformation.
   * @property {string} [affinityId] An identifier for the Node on which the
   * Task ran, which can be passed when adding a Task to request that the Task
   * be scheduled on this Compute Node.
   * @property {string} [nodeUrl] The URL of the Compute Node on which the Task
   * ran. .
   * @property {string} [poolId] The ID of the Pool on which the Task ran.
   * @property {string} [nodeId] The ID of the Compute Node on which the Task
   * ran.
   * @property {string} [taskRootDirectory] The root directory of the Task on
   * the Compute Node.
   * @property {string} [taskRootDirectoryUrl] The URL to the root directory of
   * the Task on the Compute Node.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ComputeNodeInformation
   *
   * @returns {object} metadata of ComputeNodeInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ComputeNodeInformation',
      type: {
        name: 'Composite',
        className: 'ComputeNodeInformation',
        modelProperties: {
          affinityId: {
            required: false,
            serializedName: 'affinityId',
            type: {
              name: 'String'
            }
          },
          nodeUrl: {
            required: false,
            serializedName: 'nodeUrl',
            type: {
              name: 'String'
            }
          },
          poolId: {
            required: false,
            serializedName: 'poolId',
            type: {
              name: 'String'
            }
          },
          nodeId: {
            required: false,
            serializedName: 'nodeId',
            type: {
              name: 'String'
            }
          },
          taskRootDirectory: {
            required: false,
            serializedName: 'taskRootDirectory',
            type: {
              name: 'String'
            }
          },
          taskRootDirectoryUrl: {
            required: false,
            serializedName: 'taskRootDirectoryUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ComputeNodeInformation;
