/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary A user Account for RDP or SSH access on a Compute Node.
  *
 */
class ComputeNodeUser {
  /**
   * Create a ComputeNodeUser.
   * @property {string} name The user name of the Account.
   * @property {boolean} [isAdmin] Whether the Account should be an
   * administrator on the Compute Node. The default value is false.
   * @property {date} [expiryTime] The time at which the Account should expire.
   * If omitted, the default is 1 day from the current time. For Linux Compute
   * Nodes, the expiryTime has a precision up to a day.
   * @property {string} [password] The password of the Account. The password is
   * required for Windows Compute Nodes (those created with
   * 'cloudServiceConfiguration', or created with 'virtualMachineConfiguration'
   * using a Windows Image reference). For Linux Compute Nodes, the password
   * can optionally be specified along with the sshPublicKey property.
   * @property {string} [sshPublicKey] The SSH public key that can be used for
   * remote login to the Compute Node. The public key should be compatible with
   * OpenSSH encoding and should be base 64 encoded. This property can be
   * specified only for Linux Compute Nodes. If this is specified for a Windows
   * Compute Node, then the Batch service rejects the request; if you are
   * calling the REST API directly, the HTTP status code is 400 (Bad Request).
   */
  constructor() {
  }

  /**
   * Defines the metadata of ComputeNodeUser
   *
   * @returns {object} metadata of ComputeNodeUser
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ComputeNodeUser',
      type: {
        name: 'Composite',
        className: 'ComputeNodeUser',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          isAdmin: {
            required: false,
            serializedName: 'isAdmin',
            type: {
              name: 'Boolean'
            }
          },
          expiryTime: {
            required: false,
            serializedName: 'expiryTime',
            type: {
              name: 'DateTime'
            }
          },
          password: {
            required: false,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          },
          sshPublicKey: {
            required: false,
            serializedName: 'sshPublicKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ComputeNodeUser;
