/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Specifies how the Batch service responds to a particular exit
 * condition.
  *
 */
class ExitOptions {
  /**
   * Create a ExitOptions.
   * @property {string} [jobAction] An action to take on the Job containing the
   * Task, if the Task completes with the given exit condition and the Job's
   * onTaskFailed property is 'performExitOptionsJobAction'. The default is
   * none for exit code 0 and terminate for all other exit conditions. If the
   * Job's onTaskFailed property is noaction, then specifying this property
   * returns an error and the add Task request fails with an invalid property
   * value error; if you are calling the REST API directly, the HTTP status
   * code is 400 (Bad Request). Possible values include: 'none', 'disable',
   * 'terminate'
   * @property {string} [dependencyAction] An action that the Batch service
   * performs on Tasks that depend on this Task. Possible values are 'satisfy'
   * (allowing dependent tasks to progress) and 'block' (dependent tasks
   * continue to wait). Batch does not yet support cancellation of dependent
   * tasks. Possible values include: 'satisfy', 'block'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExitOptions
   *
   * @returns {object} metadata of ExitOptions
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExitOptions',
      type: {
        name: 'Composite',
        className: 'ExitOptions',
        modelProperties: {
          jobAction: {
            required: false,
            serializedName: 'jobAction',
            type: {
              name: 'Enum',
              allowedValues: [ 'none', 'disable', 'terminate' ]
            }
          },
          dependencyAction: {
            required: false,
            serializedName: 'dependencyAction',
            type: {
              name: 'Enum',
              allowedValues: [ 'satisfy', 'block' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ExitOptions;
