/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary An error encountered by the Batch service when scheduling a Job.
  *
 */
class JobSchedulingError {
  /**
   * Create a JobSchedulingError.
   * @property {string} category The category of the Job scheduling error.
   * Possible values include: 'userError', 'serverError'
   * @property {string} [code] An identifier for the Job scheduling error.
   * Codes are invariant and are intended to be consumed programmatically.
   * @property {string} [message] A message describing the Job scheduling
   * error, intended to be suitable for display in a user interface.
   * @property {array} [details] A list of additional error details related to
   * the scheduling error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobSchedulingError
   *
   * @returns {object} metadata of JobSchedulingError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobSchedulingError',
      type: {
        name: 'Composite',
        className: 'JobSchedulingError',
        modelProperties: {
          category: {
            required: true,
            serializedName: 'category',
            type: {
              name: 'Enum',
              allowedValues: [ 'userError', 'serverError' ]
            }
          },
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NameValuePairElementType',
                  type: {
                    name: 'Composite',
                    className: 'NameValuePair'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = JobSchedulingError;
