/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Information about the Compute Node agent.
  *
 * The Batch Compute Node agent is a program that runs on each Compute Node in
 * the Pool and provides Batch capability on the Compute Node.
 *
 */
class NodeAgentInformation {
  /**
   * Create a NodeAgentInformation.
   * @property {string} version The version of the Batch Compute Node agent
   * running on the Compute Node. This version number can be checked against
   * the Compute Node agent release notes located at
   * https://github.com/Azure/Batch/blob/master/changelogs/nodeagent/CHANGELOG.md.
   * @property {date} lastUpdateTime The time when the Compute Node agent was
   * updated on the Compute Node. This is the most recent time that the Compute
   * Node agent was updated to a new version.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NodeAgentInformation
   *
   * @returns {object} metadata of NodeAgentInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeAgentInformation',
      type: {
        name: 'Composite',
        className: 'NodeAgentInformation',
        modelProperties: {
          version: {
            required: true,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          },
          lastUpdateTime: {
            required: true,
            serializedName: 'lastUpdateTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = NodeAgentInformation;
