/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Options for disabling scheduling on a Compute Node.
  *
 */
class NodeDisableSchedulingParameter {
  /**
   * Create a NodeDisableSchedulingParameter.
   * @property {string} [nodeDisableSchedulingOption] What to do with currently
   * running Tasks when disabling Task scheduling on the Compute Node. The
   * default value is requeue. Possible values include: 'requeue', 'terminate',
   * 'taskCompletion'
   */
  constructor() {
  }

  /**
   * Defines the metadata of NodeDisableSchedulingParameter
   *
   * @returns {object} metadata of NodeDisableSchedulingParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeDisableSchedulingParameter',
      type: {
        name: 'Composite',
        className: 'NodeDisableSchedulingParameter',
        modelProperties: {
          nodeDisableSchedulingOption: {
            required: false,
            serializedName: 'nodeDisableSchedulingOption',
            type: {
              name: 'Enum',
              allowedValues: [ 'requeue', 'terminate', 'taskCompletion' ]
            }
          }
        }
      }
    };
  }
}

module.exports = NodeDisableSchedulingParameter;
