/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * CNTK (aka Microsoft Cognitive Toolkit) job settings.
 *
 */
class CNTKsettings {
  /**
   * Create a CNTKsettings.
   * @member {string} [languageType] Language type. The language to use for
   * launching CNTK (aka Microsoft Cognitive Toolkit) job. Valid values are
   * 'BrainScript' or 'Python'.
   * @member {string} [configFilePath] Config file path. Specifies the path of
   * the BrainScript config file. This property can be specified only if the
   * languageType is 'BrainScript'.
   * @member {string} [pythonScriptFilePath] Python script file path. Python
   * script to execute. This property can be specified only if the languageType
   * is 'Python'.
   * @member {string} [pythonInterpreterPath] Python interpreter path. The path
   * to the Python interpreter. This property can be specified only if the
   * languageType is 'Python'.
   * @member {string} [commandLineArgs] Command line arguments. Command line
   * arguments that need to be passed to the python script or cntk executable.
   * @member {number} [processCount] Process count. Number of processes to
   * launch for the job execution. The default value for this property is equal
   * to nodeCount property
   */
  constructor() {
  }

  /**
   * Defines the metadata of CNTKsettings
   *
   * @returns {object} metadata of CNTKsettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CNTKsettings',
      type: {
        name: 'Composite',
        className: 'CNTKsettings',
        modelProperties: {
          languageType: {
            required: false,
            serializedName: 'languageType',
            type: {
              name: 'String'
            }
          },
          configFilePath: {
            required: false,
            serializedName: 'configFilePath',
            type: {
              name: 'String'
            }
          },
          pythonScriptFilePath: {
            required: false,
            serializedName: 'pythonScriptFilePath',
            type: {
              name: 'String'
            }
          },
          pythonInterpreterPath: {
            required: false,
            serializedName: 'pythonInterpreterPath',
            type: {
              name: 'String'
            }
          },
          commandLineArgs: {
            required: false,
            serializedName: 'commandLineArgs',
            type: {
              name: 'String'
            }
          },
          processCount: {
            required: false,
            serializedName: 'processCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = CNTKsettings;
