/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the settings for Horovod job.
 *
 */
class HorovodSettings {
  /**
   * Create a HorovodSettings.
   * @member {string} pythonScriptFilePath Python script file path. The python
   * script to execute.
   * @member {string} [pythonInterpreterPath] Python interpreter path. The path
   * to the Python interpreter.
   * @member {string} [commandLineArgs] Command line arguments. Command line
   * arguments that need to be passed to the python script.
   * @member {number} [processCount] Process count. Number of processes to
   * launch for the job execution. The default value for this property is equal
   * to nodeCount property
   */
  constructor() {
  }

  /**
   * Defines the metadata of HorovodSettings
   *
   * @returns {object} metadata of HorovodSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HorovodSettings',
      type: {
        name: 'Composite',
        className: 'HorovodSettings',
        modelProperties: {
          pythonScriptFilePath: {
            required: true,
            serializedName: 'pythonScriptFilePath',
            type: {
              name: 'String'
            }
          },
          pythonInterpreterPath: {
            required: false,
            serializedName: 'pythonInterpreterPath',
            type: {
              name: 'String'
            }
          },
          commandLineArgs: {
            required: false,
            serializedName: 'commandLineArgs',
            type: {
              name: 'String'
            }
          },
          processCount: {
            required: false,
            serializedName: 'processCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = HorovodSettings;
