/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Manual scale settings for the cluster.
 *
 */
class ManualScaleSettings {
  /**
   * Create a ManualScaleSettings.
   * @member {number} targetNodeCount Target node count. The desired number of
   * compute nodes in the Cluster. Default is 0. Default value: 0 .
   * @member {string} [nodeDeallocationOption] Node deallocation options. An
   * action to be performed when the cluster size is decreasing. The default
   * value is requeue. Possible values include: 'requeue', 'terminate',
   * 'waitforjobcompletion'. Default value: 'requeue' .
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManualScaleSettings
   *
   * @returns {object} metadata of ManualScaleSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManualScaleSettings',
      type: {
        name: 'Composite',
        className: 'ManualScaleSettings',
        modelProperties: {
          targetNodeCount: {
            required: true,
            serializedName: 'targetNodeCount',
            defaultValue: 0,
            type: {
              name: 'Number'
            }
          },
          nodeDeallocationOption: {
            required: false,
            serializedName: 'nodeDeallocationOption',
            defaultValue: 'requeue',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManualScaleSettings;
