/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Schema items of the body.
 *
 */
class CreateReviewBodyItem {
  /**
   * Create a CreateReviewBodyItem.
   * @property {string} type Type of the content. Possible values include:
   * 'Image', 'Text'
   * @property {string} content Content to review.
   * @property {string} contentId Content Identifier.
   * @property {string} [callbackEndpoint] Optional CallbackEndpoint.
   * @property {array} [metadata] Optional metadata details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateReviewBodyItem
   *
   * @returns {object} metadata of CreateReviewBodyItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'createReviewBodyItem',
      type: {
        name: 'Composite',
        className: 'CreateReviewBodyItem',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'Type',
            type: {
              name: 'String'
            }
          },
          content: {
            required: true,
            serializedName: 'Content',
            type: {
              name: 'String'
            }
          },
          contentId: {
            required: true,
            serializedName: 'ContentId',
            type: {
              name: 'String'
            }
          },
          callbackEndpoint: {
            required: false,
            serializedName: 'CallbackEndpoint',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: false,
            serializedName: 'Metadata',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CreateReviewBodyItemMetadataItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'CreateReviewBodyItemMetadataItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CreateReviewBodyItem;
