/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Detected Terms details.
 *
 */
class DetectedTerms {
  /**
   * Create a DetectedTerms.
   * @property {number} [index] Index(Location) of the detected profanity term
   * in the input text content.
   * @property {number} [originalIndex] Original Index(Location) of the
   * detected profanity term in the input text content.
   * @property {number} [listId] Matched Terms list Id.
   * @property {string} [term] Detected profanity term.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DetectedTerms
   *
   * @returns {object} metadata of DetectedTerms
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DetectedTerms',
      type: {
        name: 'Composite',
        className: 'DetectedTerms',
        modelProperties: {
          index: {
            required: false,
            serializedName: 'Index',
            type: {
              name: 'Number'
            }
          },
          originalIndex: {
            required: false,
            serializedName: 'OriginalIndex',
            type: {
              name: 'Number'
            }
          },
          listId: {
            required: false,
            serializedName: 'ListId',
            type: {
              name: 'Number'
            }
          },
          term: {
            required: false,
            serializedName: 'Term',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DetectedTerms;
