/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The match details.
 *
 */
class Match {
  /**
   * Create a Match.
   * @property {number} [score] Confidence score of the image match.
   * @property {number} [matchId] The match id.
   * @property {string} [source] The source.
   * @property {array} [tags] The tags for match details.
   * @property {string} [label] The label.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Match
   *
   * @returns {object} metadata of Match
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Match',
      type: {
        name: 'Composite',
        className: 'Match',
        modelProperties: {
          score: {
            required: false,
            serializedName: 'Score',
            type: {
              name: 'Number'
            }
          },
          matchId: {
            required: false,
            serializedName: 'MatchId',
            type: {
              name: 'Number'
            }
          },
          source: {
            required: false,
            serializedName: 'Source',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'Tags',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          },
          label: {
            required: false,
            serializedName: 'Label',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Match;
