/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The response for a Match request.
 *
 */
class MatchResponse {
  /**
   * Create a MatchResponse.
   * @property {string} [trackingId] The tracking id.
   * @property {string} [cacheID] The cache id.
   * @property {boolean} [isMatch] Indicates if there is a match.
   * @property {array} [matches] The match details.
   * @property {object} [status] The evaluate status
   * @property {number} [status.code] Status code.
   * @property {string} [status.description] Status description.
   * @property {string} [status.exception] Exception status.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MatchResponse
   *
   * @returns {object} metadata of MatchResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MatchResponse',
      type: {
        name: 'Composite',
        className: 'MatchResponse',
        modelProperties: {
          trackingId: {
            required: false,
            serializedName: 'TrackingId',
            type: {
              name: 'String'
            }
          },
          cacheID: {
            required: false,
            serializedName: 'CacheID',
            type: {
              name: 'String'
            }
          },
          isMatch: {
            required: false,
            serializedName: 'IsMatch',
            type: {
              name: 'Boolean'
            }
          },
          matches: {
            required: false,
            serializedName: 'Matches',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'MatchElementType',
                  type: {
                    name: 'Composite',
                    className: 'Match'
                  }
              }
            }
          },
          status: {
            required: false,
            serializedName: 'Status',
            type: {
              name: 'Composite',
              className: 'Status'
            }
          }
        }
      }
    };
  }
}

module.exports = MatchResponse;
