/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Terms properties.
 *
 */
class Terms {
  /**
   * Create a Terms.
   * @property {object} [data] Term data details.
   * @property {string} [data.language] Language of the terms.
   * @property {array} [data.terms] List of terms.
   * @property {object} [data.status] Term Status.
   * @property {number} [data.status.code] Status code.
   * @property {string} [data.status.description] Status description.
   * @property {string} [data.status.exception] Exception status.
   * @property {string} [data.trackingId] Tracking Id.
   * @property {object} [paging] Paging details.
   * @property {number} [paging.total] Total details.
   * @property {number} [paging.limit] Limit details.
   * @property {number} [paging.offset] Offset details.
   * @property {number} [paging.returned] Returned text details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Terms
   *
   * @returns {object} metadata of Terms
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Terms',
      type: {
        name: 'Composite',
        className: 'Terms',
        modelProperties: {
          data: {
            required: false,
            serializedName: 'Data',
            type: {
              name: 'Composite',
              className: 'TermsData'
            }
          },
          paging: {
            required: false,
            serializedName: 'Paging',
            type: {
              name: 'Composite',
              className: 'TermsPaging'
            }
          }
        }
      }
    };
  }
}

module.exports = Terms;
