/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Schema items of the body.
 *
 */
class VideoFrameBodyItem {
  /**
   * Create a VideoFrameBodyItem.
   * @property {string} timestamp Timestamp of the frame.
   * @property {string} frameImage Content to review.
   * @property {array} [reviewerResultTags]
   * @property {array} [metadata] Optional metadata details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VideoFrameBodyItem
   *
   * @returns {object} metadata of VideoFrameBodyItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'videoFrameBodyItem',
      type: {
        name: 'Composite',
        className: 'VideoFrameBodyItem',
        modelProperties: {
          timestamp: {
            required: true,
            serializedName: 'Timestamp',
            type: {
              name: 'String'
            }
          },
          frameImage: {
            required: true,
            serializedName: 'FrameImage',
            type: {
              name: 'String'
            }
          },
          reviewerResultTags: {
            required: false,
            serializedName: 'ReviewerResultTags',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'VideoFrameBodyItemReviewerResultTagsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'VideoFrameBodyItemReviewerResultTagsItem'
                  }
              }
            }
          },
          metadata: {
            required: false,
            serializedName: 'Metadata',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'VideoFrameBodyItemMetadataItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'VideoFrameBodyItemMetadataItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VideoFrameBodyItem;
