/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A collection of 27-point face landmarks pointing to the important positions
 * of face components.
 *
 */
class FaceLandmarks {
  /**
   * Create a FaceLandmarks.
   * @property {object} [pupilLeft]
   * @property {number} [pupilLeft.x] The horizontal component, in pixels.
   * @property {number} [pupilLeft.y] The vertical component, in pixels.
   * @property {object} [pupilRight]
   * @property {number} [pupilRight.x] The horizontal component, in pixels.
   * @property {number} [pupilRight.y] The vertical component, in pixels.
   * @property {object} [noseTip]
   * @property {number} [noseTip.x] The horizontal component, in pixels.
   * @property {number} [noseTip.y] The vertical component, in pixels.
   * @property {object} [mouthLeft]
   * @property {number} [mouthLeft.x] The horizontal component, in pixels.
   * @property {number} [mouthLeft.y] The vertical component, in pixels.
   * @property {object} [mouthRight]
   * @property {number} [mouthRight.x] The horizontal component, in pixels.
   * @property {number} [mouthRight.y] The vertical component, in pixels.
   * @property {object} [eyebrowLeftOuter]
   * @property {number} [eyebrowLeftOuter.x] The horizontal component, in
   * pixels.
   * @property {number} [eyebrowLeftOuter.y] The vertical component, in pixels.
   * @property {object} [eyebrowLeftInner]
   * @property {number} [eyebrowLeftInner.x] The horizontal component, in
   * pixels.
   * @property {number} [eyebrowLeftInner.y] The vertical component, in pixels.
   * @property {object} [eyeLeftOuter]
   * @property {number} [eyeLeftOuter.x] The horizontal component, in pixels.
   * @property {number} [eyeLeftOuter.y] The vertical component, in pixels.
   * @property {object} [eyeLeftTop]
   * @property {number} [eyeLeftTop.x] The horizontal component, in pixels.
   * @property {number} [eyeLeftTop.y] The vertical component, in pixels.
   * @property {object} [eyeLeftBottom]
   * @property {number} [eyeLeftBottom.x] The horizontal component, in pixels.
   * @property {number} [eyeLeftBottom.y] The vertical component, in pixels.
   * @property {object} [eyeLeftInner]
   * @property {number} [eyeLeftInner.x] The horizontal component, in pixels.
   * @property {number} [eyeLeftInner.y] The vertical component, in pixels.
   * @property {object} [eyebrowRightInner]
   * @property {number} [eyebrowRightInner.x] The horizontal component, in
   * pixels.
   * @property {number} [eyebrowRightInner.y] The vertical component, in
   * pixels.
   * @property {object} [eyebrowRightOuter]
   * @property {number} [eyebrowRightOuter.x] The horizontal component, in
   * pixels.
   * @property {number} [eyebrowRightOuter.y] The vertical component, in
   * pixels.
   * @property {object} [eyeRightInner]
   * @property {number} [eyeRightInner.x] The horizontal component, in pixels.
   * @property {number} [eyeRightInner.y] The vertical component, in pixels.
   * @property {object} [eyeRightTop]
   * @property {number} [eyeRightTop.x] The horizontal component, in pixels.
   * @property {number} [eyeRightTop.y] The vertical component, in pixels.
   * @property {object} [eyeRightBottom]
   * @property {number} [eyeRightBottom.x] The horizontal component, in pixels.
   * @property {number} [eyeRightBottom.y] The vertical component, in pixels.
   * @property {object} [eyeRightOuter]
   * @property {number} [eyeRightOuter.x] The horizontal component, in pixels.
   * @property {number} [eyeRightOuter.y] The vertical component, in pixels.
   * @property {object} [noseRootLeft]
   * @property {number} [noseRootLeft.x] The horizontal component, in pixels.
   * @property {number} [noseRootLeft.y] The vertical component, in pixels.
   * @property {object} [noseRootRight]
   * @property {number} [noseRootRight.x] The horizontal component, in pixels.
   * @property {number} [noseRootRight.y] The vertical component, in pixels.
   * @property {object} [noseLeftAlarTop]
   * @property {number} [noseLeftAlarTop.x] The horizontal component, in
   * pixels.
   * @property {number} [noseLeftAlarTop.y] The vertical component, in pixels.
   * @property {object} [noseRightAlarTop]
   * @property {number} [noseRightAlarTop.x] The horizontal component, in
   * pixels.
   * @property {number} [noseRightAlarTop.y] The vertical component, in pixels.
   * @property {object} [noseLeftAlarOutTip]
   * @property {number} [noseLeftAlarOutTip.x] The horizontal component, in
   * pixels.
   * @property {number} [noseLeftAlarOutTip.y] The vertical component, in
   * pixels.
   * @property {object} [noseRightAlarOutTip]
   * @property {number} [noseRightAlarOutTip.x] The horizontal component, in
   * pixels.
   * @property {number} [noseRightAlarOutTip.y] The vertical component, in
   * pixels.
   * @property {object} [upperLipTop]
   * @property {number} [upperLipTop.x] The horizontal component, in pixels.
   * @property {number} [upperLipTop.y] The vertical component, in pixels.
   * @property {object} [upperLipBottom]
   * @property {number} [upperLipBottom.x] The horizontal component, in pixels.
   * @property {number} [upperLipBottom.y] The vertical component, in pixels.
   * @property {object} [underLipTop]
   * @property {number} [underLipTop.x] The horizontal component, in pixels.
   * @property {number} [underLipTop.y] The vertical component, in pixels.
   * @property {object} [underLipBottom]
   * @property {number} [underLipBottom.x] The horizontal component, in pixels.
   * @property {number} [underLipBottom.y] The vertical component, in pixels.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FaceLandmarks
   *
   * @returns {object} metadata of FaceLandmarks
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FaceLandmarks',
      type: {
        name: 'Composite',
        className: 'FaceLandmarks',
        modelProperties: {
          pupilLeft: {
            required: false,
            serializedName: 'pupilLeft',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          pupilRight: {
            required: false,
            serializedName: 'pupilRight',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          noseTip: {
            required: false,
            serializedName: 'noseTip',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          mouthLeft: {
            required: false,
            serializedName: 'mouthLeft',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          mouthRight: {
            required: false,
            serializedName: 'mouthRight',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyebrowLeftOuter: {
            required: false,
            serializedName: 'eyebrowLeftOuter',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyebrowLeftInner: {
            required: false,
            serializedName: 'eyebrowLeftInner',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyeLeftOuter: {
            required: false,
            serializedName: 'eyeLeftOuter',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyeLeftTop: {
            required: false,
            serializedName: 'eyeLeftTop',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyeLeftBottom: {
            required: false,
            serializedName: 'eyeLeftBottom',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyeLeftInner: {
            required: false,
            serializedName: 'eyeLeftInner',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyebrowRightInner: {
            required: false,
            serializedName: 'eyebrowRightInner',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyebrowRightOuter: {
            required: false,
            serializedName: 'eyebrowRightOuter',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyeRightInner: {
            required: false,
            serializedName: 'eyeRightInner',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyeRightTop: {
            required: false,
            serializedName: 'eyeRightTop',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyeRightBottom: {
            required: false,
            serializedName: 'eyeRightBottom',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          eyeRightOuter: {
            required: false,
            serializedName: 'eyeRightOuter',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          noseRootLeft: {
            required: false,
            serializedName: 'noseRootLeft',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          noseRootRight: {
            required: false,
            serializedName: 'noseRootRight',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          noseLeftAlarTop: {
            required: false,
            serializedName: 'noseLeftAlarTop',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          noseRightAlarTop: {
            required: false,
            serializedName: 'noseRightAlarTop',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          noseLeftAlarOutTip: {
            required: false,
            serializedName: 'noseLeftAlarOutTip',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          noseRightAlarOutTip: {
            required: false,
            serializedName: 'noseRightAlarOutTip',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          upperLipTop: {
            required: false,
            serializedName: 'upperLipTop',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          upperLipBottom: {
            required: false,
            serializedName: 'upperLipBottom',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          underLipTop: {
            required: false,
            serializedName: 'underLipTop',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          },
          underLipBottom: {
            required: false,
            serializedName: 'underLipBottom',
            type: {
              name: 'Composite',
              className: 'Coordinate'
            }
          }
        }
      }
    };
  }
}

module.exports = FaceLandmarks;
