/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An array of face groups based on face similarity.
 *
 */
class GroupResult {
  /**
   * Create a GroupResult.
   * @property {array} groups A partition of the original faces based on face
   * similarity. Groups are ranked by number of faces
   * @property {array} [messyGroup] Face ids array of faces that cannot find
   * any similar faces from original faces.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GroupResult
   *
   * @returns {object} metadata of GroupResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GroupResult',
      type: {
        name: 'Composite',
        className: 'GroupResult',
        modelProperties: {
          groups: {
            required: true,
            serializedName: 'groups',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ArrayElementType',
                  type: {
                    name: 'Sequence',
                    element: {
                        required: false,
                        serializedName: 'UuidElementType',
                        type: {
                          name: 'String'
                        }
                    }
                  }
              }
            }
          },
          messyGroup: {
            required: false,
            serializedName: 'messyGroup',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UuidElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = GroupResult;
