/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Input to create KB.
 *
 */
class CreateKbInputDTO {
  /**
   * Create a CreateKbInputDTO.
   * @property {array} [qnaList] List of QNA to be added to the index. Ids are
   * generated by the service and should be omitted.
   * @property {array} [urls] List of URLs to be added to knowledgebase.
   * @property {array} [files] List of files to be added to knowledgebase.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateKbInputDTO
   *
   * @returns {object} metadata of CreateKbInputDTO
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateKbInputDTO',
      type: {
        name: 'Composite',
        className: 'CreateKbInputDTO',
        modelProperties: {
          qnaList: {
            required: false,
            serializedName: 'qnaList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'QnADTOElementType',
                  type: {
                    name: 'Composite',
                    className: 'QnADTO'
                  }
              }
            }
          },
          urls: {
            required: false,
            serializedName: 'urls',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          files: {
            required: false,
            serializedName: 'files',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'FileDTOElementType',
                  type: {
                    name: 'Composite',
                    className: 'FileDTO'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CreateKbInputDTO;
