/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Schema for EndpointKeys generate/refresh operations.
 *
 */
class EndpointKeysDTO {
  /**
   * Create a EndpointKeysDTO.
   * @property {string} [primaryEndpointKey] Primary Access Key.
   * @property {string} [secondaryEndpointKey] Secondary Access Key.
   * @property {string} [installedVersion] Current version of runtime.
   * @property {string} [lastStableVersion] Latest version of runtime.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EndpointKeysDTO
   *
   * @returns {object} metadata of EndpointKeysDTO
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EndpointKeysDTO',
      type: {
        name: 'Composite',
        className: 'EndpointKeysDTO',
        modelProperties: {
          primaryEndpointKey: {
            required: false,
            serializedName: 'primaryEndpointKey',
            type: {
              name: 'String'
            }
          },
          secondaryEndpointKey: {
            required: false,
            serializedName: 'secondaryEndpointKey',
            type: {
              name: 'String'
            }
          },
          installedVersion: {
            required: false,
            serializedName: 'installedVersion',
            type: {
              name: 'String'
            }
          },
          lastStableVersion: {
            required: false,
            serializedName: 'lastStableVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EndpointKeysDTO;
