/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object describing additional category details.
 *
 */
class CategoryDetail {
  /**
   * Create a CategoryDetail.
   * @property {array} [celebrities] An array of celebrities if any identified.
   * @property {array} [landmarks] An array of landmarks if any identified.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CategoryDetail
   *
   * @returns {object} metadata of CategoryDetail
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CategoryDetail',
      type: {
        name: 'Composite',
        className: 'CategoryDetail',
        modelProperties: {
          celebrities: {
            required: false,
            nullable: true,
            serializedName: 'celebrities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CelebritiesModelElementType',
                  type: {
                    name: 'Composite',
                    className: 'CelebritiesModel'
                  }
              }
            }
          },
          landmarks: {
            required: false,
            nullable: true,
            serializedName: 'landmarks',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'LandmarksModelElementType',
                  type: {
                    name: 'Composite',
                    className: 'LandmarksModel'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CategoryDetail;
