/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object providing possible image types and matching confidence levels.
 *
 */
class ImageType {
  /**
   * Create a ImageType.
   * @property {number} [clipArtType] Confidence level that the image is a clip
   * art.
   * @property {number} [lineDrawingType] Confidence level that the image is a
   * line drawing.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageType
   *
   * @returns {object} metadata of ImageType
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageType',
      type: {
        name: 'Composite',
        className: 'ImageType',
        modelProperties: {
          clipArtType: {
            required: false,
            nullable: false,
            serializedName: 'clipArtType',
            type: {
              name: 'Number'
            }
          },
          lineDrawingType: {
            required: false,
            nullable: false,
            serializedName: 'lineDrawingType',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ImageType;
