/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The results of a image tag operation, including any tags and image metadata.
 *
 */
class TagResult {
  /**
   * Create a TagResult.
   * @property {array} [tags] A list of tags with confidence level.
   * @property {string} [requestId] Id of the REST API request.
   * @property {object} [metadata]
   * @property {number} [metadata.width] Image width, in pixels.
   * @property {number} [metadata.height] Image height, in pixels.
   * @property {string} [metadata.format] Image format.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TagResult
   *
   * @returns {object} metadata of TagResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TagResult',
      type: {
        name: 'Composite',
        className: 'TagResult',
        modelProperties: {
          tags: {
            required: false,
            nullable: true,
            serializedName: 'tags',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ImageTagElementType',
                  type: {
                    name: 'Composite',
                    className: 'ImageTag'
                  }
              }
            }
          },
          requestId: {
            required: false,
            nullable: true,
            serializedName: 'requestId',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: false,
            serializedName: 'metadata',
            type: {
              name: 'Composite',
              className: 'ImageMetadata'
            }
          }
        }
      }
    };
  }
}

module.exports = TagResult;
