/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of a run argument.
 *
 */
class Argument {
  /**
   * Create a Argument.
   * @property {string} name The name of the argument.
   * @property {string} value The value of the argument.
   * @property {boolean} [isSecret] Flag to indicate whether the argument
   * represents a secret and want to be removed from build logs. Default value:
   * false .
   */
  constructor() {
  }

  /**
   * Defines the metadata of Argument
   *
   * @returns {object} metadata of Argument
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Argument',
      type: {
        name: 'Composite',
        className: 'Argument',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          isSecret: {
            required: false,
            serializedName: 'isSecret',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = Argument;
