/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters for updating a build step.
 *
 */
class BuildStepUpdateParameters {
  /**
   * Create a BuildStepUpdateParameters.
   * @member {object} [properties] The properties for updating a build step.
   * @member {string} [properties.type] Polymorphic Discriminator
   * @member {object} [tags] The ARM resource tags.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BuildStepUpdateParameters
   *
   * @returns {object} metadata of BuildStepUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BuildStepUpdateParameters',
      type: {
        name: 'Composite',
        className: 'BuildStepUpdateParameters',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'type',
                clientName: 'type'
              },
              uberParent: 'BuildStepPropertiesUpdateParameters',
              className: 'BuildStepPropertiesUpdateParameters'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = BuildStepUpdateParameters;
