/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The image update trigger that caused a build.
 *
 */
class ImageUpdateTrigger {
  /**
   * Create a ImageUpdateTrigger.
   * @property {string} [id] The unique ID of the trigger.
   * @property {date} [timestamp] The timestamp when the image update happened.
   * @property {array} [images] The list of image updates that caused the
   * build.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageUpdateTrigger
   *
   * @returns {object} metadata of ImageUpdateTrigger
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageUpdateTrigger',
      type: {
        name: 'Composite',
        className: 'ImageUpdateTrigger',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          timestamp: {
            required: false,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          },
          images: {
            required: false,
            serializedName: 'images',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ImageDescriptorElementType',
                  type: {
                    name: 'Composite',
                    className: 'ImageDescriptor'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ImageUpdateTrigger;
