/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ImportSourceCredentials.
 */
class ImportSourceCredentials {
  /**
   * Create a ImportSourceCredentials.
   * @property {string} [username] The username to authenticate with the source
   * registry.
   * @property {string} password The password used to authenticate with the
   * source registry.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImportSourceCredentials
   *
   * @returns {object} metadata of ImportSourceCredentials
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImportSourceCredentials',
      type: {
        name: 'Composite',
        className: 'ImportSourceCredentials',
        modelProperties: {
          username: {
            required: false,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          },
          password: {
            required: true,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ImportSourceCredentials;
