/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The container Http Get settings, for liveness or readiness probe
 *
 */
class ContainerHttpGet {
  /**
   * Create a ContainerHttpGet.
   * @member {string} [path] The path to probe.
   * @member {number} port The port number to probe.
   * @member {string} [scheme] The scheme. Possible values include: 'http',
   * 'https'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerHttpGet
   *
   * @returns {object} metadata of ContainerHttpGet
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerHttpGet',
      type: {
        name: 'Composite',
        className: 'ContainerHttpGet',
        modelProperties: {
          path: {
            required: false,
            serializedName: 'path',
            type: {
              name: 'String'
            }
          },
          port: {
            required: true,
            serializedName: 'port',
            type: {
              name: 'Number'
            }
          },
          scheme: {
            required: false,
            serializedName: 'scheme',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerHttpGet;
