/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Reference to a secret stored in Azure Key Vault.
 *
 */
class KeyVaultSecretRef {
  /**
   * Create a KeyVaultSecretRef.
   * @property {string} vaultID Key vault identifier.
   * @property {string} secretName The secret name.
   * @property {string} [version] The secret version.
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyVaultSecretRef
   *
   * @returns {object} metadata of KeyVaultSecretRef
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyVaultSecretRef',
      type: {
        name: 'Composite',
        className: 'KeyVaultSecretRef',
        modelProperties: {
          vaultID: {
            required: true,
            serializedName: 'vaultID',
            type: {
              name: 'String'
            }
          },
          secretName: {
            required: true,
            serializedName: 'secretName',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyVaultSecretRef;
