/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * AADProfile specifies attributes for Azure Active Directory integration.
 *
 */
class ManagedClusterAADProfile {
  /**
   * Create a ManagedClusterAADProfile.
   * @property {string} clientAppID The client AAD application ID.
   * @property {string} serverAppID The server AAD application ID.
   * @property {string} [serverAppSecret] The server AAD application secret.
   * @property {string} [tenantID] The AAD tenant ID to use for authentication.
   * If not specified, will use the tenant of the deployment subscription.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagedClusterAADProfile
   *
   * @returns {object} metadata of ManagedClusterAADProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagedClusterAADProfile',
      type: {
        name: 'Composite',
        className: 'ManagedClusterAADProfile',
        modelProperties: {
          clientAppID: {
            required: true,
            serializedName: 'clientAppID',
            type: {
              name: 'String'
            }
          },
          serverAppID: {
            required: true,
            serializedName: 'serverAppID',
            type: {
              name: 'String'
            }
          },
          serverAppSecret: {
            required: false,
            serializedName: 'serverAppSecret',
            type: {
              name: 'String'
            }
          },
          tenantID: {
            required: false,
            serializedName: 'tenantID',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagedClusterAADProfile;
