/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The list of available upgrade versions.
 *
 */
class ManagedClusterPoolUpgradeProfile {
  /**
   * Create a ManagedClusterPoolUpgradeProfile.
   * @property {string} kubernetesVersion Kubernetes version (major, minor,
   * patch).
   * @property {string} [name] Pool name.
   * @property {string} osType OsType to be used to specify os type. Choose
   * from Linux and Windows. Default to Linux. Possible values include:
   * 'Linux', 'Windows'. Default value: 'Linux' .
   * @property {array} [upgrades] List of orchestrator types and versions
   * available for upgrade.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagedClusterPoolUpgradeProfile
   *
   * @returns {object} metadata of ManagedClusterPoolUpgradeProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagedClusterPoolUpgradeProfile',
      type: {
        name: 'Composite',
        className: 'ManagedClusterPoolUpgradeProfile',
        modelProperties: {
          kubernetesVersion: {
            required: true,
            serializedName: 'kubernetesVersion',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          osType: {
            required: true,
            serializedName: 'osType',
            defaultValue: 'Linux',
            type: {
              name: 'String'
            }
          },
          upgrades: {
            required: false,
            serializedName: 'upgrades',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ManagedClusterPoolUpgradeProfile;
