/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The list of versions for supported orchestrators.
 *
 */
class OrchestratorVersionProfileListResult {
  /**
   * Create a OrchestratorVersionProfileListResult.
   * @property {string} [id] Id of the orchestrator version profile list
   * result.
   * @property {string} [name] Name of the orchestrator version profile list
   * result.
   * @property {string} [type] Type of the orchestrator version profile list
   * result.
   * @property {array} orchestrators List of orchestrator version profiles.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OrchestratorVersionProfileListResult
   *
   * @returns {object} metadata of OrchestratorVersionProfileListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OrchestratorVersionProfileListResult',
      type: {
        name: 'Composite',
        className: 'OrchestratorVersionProfileListResult',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          orchestrators: {
            required: true,
            serializedName: 'properties.orchestrators',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'OrchestratorVersionProfileElementType',
                  type: {
                    name: 'Composite',
                    className: 'OrchestratorVersionProfile'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OrchestratorVersionProfileListResult;
