/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Virtual Network ACL Rule object
 *
 */
class VirtualNetworkRule {
  /**
   * Create a VirtualNetworkRule.
   * @member {string} [id] Resource ID of a subnet, for example:
   * /subscriptions/{subscriptionId}/resourceGroups/{groupName}/providers/Microsoft.Network/virtualNetworks/{virtualNetworkName}/subnets/{subnetName}.
   * @member {boolean} [ignoreMissingVNetServiceEndpoint] Create firewall rule
   * before the virtual network has vnet service endpoint enabled.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualNetworkRule
   *
   * @returns {object} metadata of VirtualNetworkRule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualNetworkRule',
      type: {
        name: 'Composite',
        className: 'VirtualNetworkRule',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          ignoreMissingVNetServiceEndpoint: {
            required: false,
            serializedName: 'ignoreMissingVNetServiceEndpoint',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualNetworkRule;
