/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Result of an image prediction request.
 *
 */
class ImagePrediction {
  /**
   * Create a ImagePrediction.
   * @property {uuid} [id] Prediction Id.
   * @property {uuid} [project] Project Id.
   * @property {uuid} [iteration] Iteration Id.
   * @property {date} [created] Date this prediction was created.
   * @property {array} [predictions] List of predictions.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImagePrediction
   *
   * @returns {object} metadata of ImagePrediction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImagePrediction',
      type: {
        name: 'Composite',
        className: 'ImagePrediction',
        modelProperties: {
          id: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          project: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'project',
            type: {
              name: 'String'
            }
          },
          iteration: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'iteration',
            type: {
              name: 'String'
            }
          },
          created: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'created',
            type: {
              name: 'DateTime'
            }
          },
          predictions: {
            required: false,
            readOnly: true,
            serializedName: 'predictions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PredictionElementType',
                  type: {
                    name: 'Composite',
                    className: 'Prediction'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ImagePrediction;
