/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Image model to be sent as JSON.
 *
 */
class Image {
  /**
   * Create a Image.
   * @property {uuid} [id] Id of the image.
   * @property {date} [created] Date the image was created.
   * @property {number} [width] Width of the image.
   * @property {number} [height] Height of the image.
   * @property {string} [resizedImageUri] The URI to the (resized) image used
   * for training.
   * @property {string} [thumbnailUri] The URI to the thumbnail of the original
   * image.
   * @property {string} [originalImageUri] The URI to the original uploaded
   * image.
   * @property {array} [tags] Tags associated with this image.
   * @property {array} [regions] Regions associated with this image.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Image
   *
   * @returns {object} metadata of Image
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Image',
      type: {
        name: 'Composite',
        className: 'Image',
        modelProperties: {
          id: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          created: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'created',
            type: {
              name: 'DateTime'
            }
          },
          width: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'width',
            type: {
              name: 'Number'
            }
          },
          height: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'height',
            type: {
              name: 'Number'
            }
          },
          resizedImageUri: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'resizedImageUri',
            type: {
              name: 'String'
            }
          },
          thumbnailUri: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'thumbnailUri',
            type: {
              name: 'String'
            }
          },
          originalImageUri: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'originalImageUri',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'tags',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ImageTagElementType',
                  type: {
                    name: 'Composite',
                    className: 'ImageTag'
                  }
              }
            }
          },
          regions: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'regions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ImageRegionElementType',
                  type: {
                    name: 'Composite',
                    className: 'ImageRegion'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Image;
