/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ImageIdCreateEntry.
 */
class ImageIdCreateEntry {
  /**
   * Create a ImageIdCreateEntry.
   * @property {uuid} [id] Id of the image.
   * @property {array} [tagIds]
   * @property {array} [regions]
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageIdCreateEntry
   *
   * @returns {object} metadata of ImageIdCreateEntry
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageIdCreateEntry',
      type: {
        name: 'Composite',
        className: 'ImageIdCreateEntry',
        modelProperties: {
          id: {
            required: false,
            nullable: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          tagIds: {
            required: false,
            serializedName: 'tagIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UuidElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          regions: {
            required: false,
            serializedName: 'regions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RegionElementType',
                  type: {
                    name: 'Composite',
                    className: 'Region'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ImageIdCreateEntry;
