/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a PredictionQueryToken.
 */
class PredictionQueryToken {
  /**
   * Create a PredictionQueryToken.
   * @property {string} [session]
   * @property {string} [continuation]
   * @property {number} [maxCount]
   * @property {string} [orderBy] Possible values include: 'Newest', 'Oldest',
   * 'Suggested'
   * @property {array} [tags]
   * @property {uuid} [iterationId]
   * @property {date} [startTime]
   * @property {date} [endTime]
   * @property {string} [application]
   */
  constructor() {
  }

  /**
   * Defines the metadata of PredictionQueryToken
   *
   * @returns {object} metadata of PredictionQueryToken
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PredictionQueryToken',
      type: {
        name: 'Composite',
        className: 'PredictionQueryToken',
        modelProperties: {
          session: {
            required: false,
            nullable: false,
            serializedName: 'session',
            type: {
              name: 'String'
            }
          },
          continuation: {
            required: false,
            nullable: false,
            serializedName: 'continuation',
            type: {
              name: 'String'
            }
          },
          maxCount: {
            required: false,
            nullable: false,
            serializedName: 'maxCount',
            type: {
              name: 'Number'
            }
          },
          orderBy: {
            required: false,
            nullable: false,
            serializedName: 'orderBy',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PredictionQueryTagElementType',
                  type: {
                    name: 'Composite',
                    className: 'PredictionQueryTag'
                  }
              }
            }
          },
          iterationId: {
            required: false,
            nullable: true,
            serializedName: 'iterationId',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            nullable: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            nullable: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          application: {
            required: false,
            nullable: false,
            serializedName: 'application',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PredictionQueryToken;
