/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Copy log details for an storage account
 *
 * @extends models['CopyLogDetails']
 */
class AccountCopyLogDetails extends models['CopyLogDetails'] {
  /**
   * Create a AccountCopyLogDetails.
   * @member {string} accountName Destination account name.
   * @member {string} copyLogLink Link for copy logs.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AccountCopyLogDetails
   *
   * @returns {object} metadata of AccountCopyLogDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Pod',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'copyLogDetailsType',
          clientName: 'copyLogDetailsType'
        },
        uberParent: 'CopyLogDetails',
        className: 'AccountCopyLogDetails',
        modelProperties: {
          copyLogDetailsType: {
            required: true,
            serializedName: 'copyLogDetailsType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          accountName: {
            required: true,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          copyLogLink: {
            required: true,
            serializedName: 'copyLogLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AccountCopyLogDetails;
