/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Disk Copy Progress
 *
 */
class DiskCopyProgress {
  /**
   * Create a DiskCopyProgress.
   * @member {string} [serialNumber] The serial number of the disk
   * @member {number} [percentComplete] Indicates the percentage completed for
   * the copy of the disk.
   * @member {string} [status] The Status of the copy. Possible values include:
   * 'NotStarted', 'InProgress', 'Completed', 'CompletedWithErrors', 'Failed'
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiskCopyProgress
   *
   * @returns {object} metadata of DiskCopyProgress
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiskCopyProgress',
      type: {
        name: 'Composite',
        className: 'DiskCopyProgress',
        modelProperties: {
          serialNumber: {
            required: false,
            serializedName: 'serialNumber',
            type: {
              name: 'String'
            }
          },
          percentComplete: {
            required: false,
            serializedName: 'percentComplete',
            type: {
              name: 'Number'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotStarted', 'InProgress', 'Completed', 'CompletedWithErrors', 'Failed' ]
            }
          }
        }
      }
    };
  }
}

module.exports = DiskCopyProgress;
