/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Pod Job Details
 *
 * @extends models['JobDetails']
 */
class PodJobDetails extends models['JobDetails'] {
  /**
   * Create a PodJobDetails.
   * @member {array} [copyProgress] Copy progress per account.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PodJobDetails
   *
   * @returns {object} metadata of PodJobDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Pod',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'jobDetailsType',
          clientName: 'jobDetailsType'
        },
        uberParent: 'JobDetails',
        className: 'PodJobDetails',
        modelProperties: {
          expectedDataSizeInTeraBytes: {
            required: false,
            serializedName: 'expectedDataSizeInTeraBytes',
            type: {
              name: 'Number'
            }
          },
          jobStages: {
            required: false,
            serializedName: 'jobStages',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'JobStagesElementType',
                  type: {
                    name: 'Composite',
                    className: 'JobStages'
                  }
              }
            }
          },
          contactDetails: {
            required: true,
            serializedName: 'contactDetails',
            type: {
              name: 'Composite',
              className: 'ContactDetails'
            }
          },
          shippingAddress: {
            required: true,
            serializedName: 'shippingAddress',
            type: {
              name: 'Composite',
              className: 'ShippingAddress'
            }
          },
          errorDetails: {
            required: false,
            serializedName: 'errorDetails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'JobErrorDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'JobErrorDetails'
                  }
              }
            }
          },
          jobDetailsType: {
            required: true,
            serializedName: 'jobDetailsType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          copyProgress: {
            required: false,
            serializedName: 'copyProgress',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CopyProgressElementType',
                  type: {
                    name: 'Composite',
                    className: 'CopyProgress'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PodJobDetails;
