/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details of the reported issue.
 *
 */
class ReportIssueDetails {
  /**
   * Create a ReportIssueDetails.
   * @member {string} [issueType] Issue Type. Possible values include:
   * 'DeviceMismatch', 'ValidationStringMismatch', 'CredentialNotWorking',
   * 'DeviceFailure'
   * @member {string} [deviceIssueType] Device Issue Type. Only used for Device
   * failure issue. Possible values include: 'DeviceTampering',
   * 'DeviceNotBootingUp', 'DeviceHealthCheckShowFailures',
   * 'NICsAreNotWorking', 'Misc'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReportIssueDetails
   *
   * @returns {object} metadata of ReportIssueDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReportIssueDetails',
      type: {
        name: 'Composite',
        className: 'ReportIssueDetails',
        modelProperties: {
          issueType: {
            required: false,
            serializedName: 'issueType',
            type: {
              name: 'Enum',
              allowedValues: [ 'DeviceMismatch', 'ValidationStringMismatch', 'CredentialNotWorking', 'DeviceFailure' ]
            }
          },
          deviceIssueType: {
            required: false,
            serializedName: 'deviceIssueType',
            type: {
              name: 'Enum',
              allowedValues: [ 'DeviceTampering', 'DeviceNotBootingUp', 'DeviceHealthCheckShowFailures', 'NICsAreNotWorking', 'Misc' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ReportIssueDetails;
