/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The JobResourceUpdateParameter.
 *
 */
class JobResourceUpdateParameter {
  /**
   * Create a JobResourceUpdateParameter.
   * @member {object} [details] Details of a job to be updated.
   * @member {object} [details.contactDetails] Contact details for notification
   * and shipping.
   * @member {string} [details.contactDetails.contactName] Contact name of the
   * person.
   * @member {string} [details.contactDetails.phone] Phone number of the
   * contact person.
   * @member {string} [details.contactDetails.phoneExtension] Phone extension
   * number of the contact person.
   * @member {string} [details.contactDetails.mobile] Mobile number of the
   * contact person.
   * @member {array} [details.contactDetails.emailList] List of Email-ids to be
   * notified about job progress.
   * @member {array} [details.contactDetails.notificationPreference]
   * Notification preference for a job stage.
   * @member {object} [details.shippingAddress] Shipping address of the
   * customer.
   * @member {string} [details.shippingAddress.streetAddress1] Street Address
   * line 1.
   * @member {string} [details.shippingAddress.streetAddress2] Street Address
   * line 2.
   * @member {string} [details.shippingAddress.streetAddress3] Street Address
   * line 3.
   * @member {string} [details.shippingAddress.city] Name of the City.
   * @member {string} [details.shippingAddress.stateOrProvince] Name of the
   * State or Province.
   * @member {string} [details.shippingAddress.country] Name of the Country.
   * @member {string} [details.shippingAddress.postalCode] Postal code.
   * @member {string} [details.shippingAddress.zipExtendedCode] Extended Zip
   * Code.
   * @member {string} [details.shippingAddress.companyName] Name of the
   * company.
   * @member {string} [details.shippingAddress.addressType] Type of address.
   * Possible values include: 'None', 'Residential', 'Commercial'
   * @member {array} [destinationAccountDetails] Destination account details.
   * @member {object} [tags] The list of key value pairs that describe the
   * resource. These tags can be used in viewing and grouping this resource
   * (across resource groups).
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobResourceUpdateParameter
   *
   * @returns {object} metadata of JobResourceUpdateParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobResourceUpdateParameter',
      type: {
        name: 'Composite',
        className: 'JobResourceUpdateParameter',
        modelProperties: {
          details: {
            required: false,
            serializedName: 'properties.details',
            type: {
              name: 'Composite',
              className: 'UpdateJobDetails'
            }
          },
          destinationAccountDetails: {
            required: false,
            serializedName: 'properties.destinationAccountDetails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DestinationAccountDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'DestinationAccountDetails'
                  }
              }
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = JobResourceUpdateParameter;
