/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Operation entity.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} [name] Name of the operation. Format:
   * {resourceProviderNamespace}/{resourceType}/{read|write|delete|action}
   * @member {object} [display] Operation display values.
   * @member {string} [display.provider] Provider name.
   * @member {string} [display.resource] Resource name.
   * @member {string} [display.operation] Localized name of the operation for
   * display purpose.
   * @member {string} [display.description] Localized description of the
   * operation for display purpose.
   * @member {object} [properties] Operation properties.
   * @member {string} [origin] Origin of the operation. Can be :
   * user|system|user,system
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            readOnly: true,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          },
          properties: {
            required: false,
            readOnly: true,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          },
          origin: {
            required: false,
            readOnly: true,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
