/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The linked integration runtime information.
 *
 */
class CreateLinkedIntegrationRuntimeRequest {
  /**
   * Create a CreateLinkedIntegrationRuntimeRequest.
   * @member {string} [name] The name of the linked integration runtime.
   * @member {string} [subscriptionId] The ID of the subscription that the
   * linked integration runtime belongs to.
   * @member {string} [dataFactoryName] The name of the data factory that the
   * linked integration runtime belongs to.
   * @member {string} [dataFactoryLocation] The location of the data factory
   * that the linked integration runtime belongs to.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateLinkedIntegrationRuntimeRequest
   *
   * @returns {object} metadata of CreateLinkedIntegrationRuntimeRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateLinkedIntegrationRuntimeRequest',
      type: {
        name: 'Composite',
        className: 'CreateLinkedIntegrationRuntimeRequest',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          subscriptionId: {
            required: false,
            serializedName: 'subscriptionId',
            type: {
              name: 'String'
            }
          },
          dataFactoryName: {
            required: false,
            serializedName: 'dataFactoryName',
            type: {
              name: 'String'
            }
          },
          dataFactoryLocation: {
            required: false,
            serializedName: 'dataFactoryLocation',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateLinkedIntegrationRuntimeRequest;
