/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * DatabricksNotebook activity.
 *
 * @extends models['ExecutionActivity']
 */
class DatabricksNotebookActivity extends models['ExecutionActivity'] {
  /**
   * Create a DatabricksNotebookActivity.
   * @member {object} notebookPath The absolute path of the notebook to be run
   * in the Databricks Workspace. This path must begin with a slash. Type:
   * string (or Expression with resultType string).
   * @member {object} [baseParameters] Base parameters to be used for each run
   * of this job.If the notebook takes a parameter that is not specified, the
   * default value from the notebook will be used.
   * @member {array} [libraries] A list of libraries to be installed on the
   * cluster that will execute the job.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DatabricksNotebookActivity
   *
   * @returns {object} metadata of DatabricksNotebookActivity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DatabricksNotebook',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'Activity',
        className: 'DatabricksNotebookActivity',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          dependsOn: {
            required: false,
            serializedName: 'dependsOn',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ActivityDependencyElementType',
                  type: {
                    name: 'Composite',
                    additionalProperties: {
                      type: {
                        name: 'Dictionary',
                        value: {
                            required: false,
                            serializedName: 'ObjectElementType',
                            type: {
                              name: 'Object'
                            }
                        }
                      }
                    },
                    className: 'ActivityDependency'
                  }
              }
            }
          },
          userProperties: {
            required: false,
            serializedName: 'userProperties',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UserPropertyElementType',
                  type: {
                    name: 'Composite',
                    className: 'UserProperty'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          linkedServiceName: {
            required: false,
            serializedName: 'linkedServiceName',
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          policy: {
            required: false,
            serializedName: 'policy',
            type: {
              name: 'Composite',
              additionalProperties: {
                type: {
                  name: 'Dictionary',
                  value: {
                      required: false,
                      serializedName: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              className: 'ActivityPolicy'
            }
          },
          notebookPath: {
            required: true,
            serializedName: 'typeProperties.notebookPath',
            type: {
              name: 'Object'
            }
          },
          baseParameters: {
            required: false,
            serializedName: 'typeProperties.baseParameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          },
          libraries: {
            required: false,
            serializedName: 'typeProperties.libraries',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Dictionary',
                    value: {
                        required: false,
                        serializedName: 'ObjectElementType',
                        type: {
                          name: 'Object'
                        }
                    }
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DatabricksNotebookActivity;
