/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Factory's git repo information.
 *
 */
class FactoryRepoConfiguration {
  /**
   * Create a FactoryRepoConfiguration.
   * @member {string} accountName Account name.
   * @member {string} repositoryName Rrepository name.
   * @member {string} collaborationBranch Collaboration branch.
   * @member {string} rootFolder Root folder.
   * @member {string} [lastCommitId] Last commit id.
   * @member {string} type Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of FactoryRepoConfiguration
   *
   * @returns {object} metadata of FactoryRepoConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FactoryRepoConfiguration',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'FactoryRepoConfiguration',
        className: 'FactoryRepoConfiguration',
        modelProperties: {
          accountName: {
            required: true,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          repositoryName: {
            required: true,
            serializedName: 'repositoryName',
            type: {
              name: 'String'
            }
          },
          collaborationBranch: {
            required: true,
            serializedName: 'collaborationBranch',
            type: {
              name: 'String'
            }
          },
          rootFolder: {
            required: true,
            serializedName: 'rootFolder',
            type: {
              name: 'String'
            }
          },
          lastCommitId: {
            required: false,
            serializedName: 'lastCommitId',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FactoryRepoConfiguration;
