/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Data Lake Store file or directory Access Control List information.
 *
 */
class AclStatusResult {
  /**
   * Create a AclStatusResult.
   * @property {object} [aclStatus] the AclStatus object for a given file or
   * directory.
   * @property {array} [aclStatus.entries] the list of ACLSpec entries on a
   * file or directory.
   * @property {string} [aclStatus.group] the group owner, an AAD Object ID.
   * @property {string} [aclStatus.owner] the user owner, an AAD Object ID.
   * @property {string} [aclStatus.permission] The octal representation of the
   * unnamed user, mask and other permissions.
   * @property {boolean} [aclStatus.stickyBit] the indicator of whether the
   * sticky bit is on or off.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AclStatusResult
   *
   * @returns {object} metadata of AclStatusResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AclStatusResult',
      type: {
        name: 'Composite',
        className: 'AclStatusResult',
        modelProperties: {
          aclStatus: {
            required: false,
            serializedName: 'aclStatus',
            type: {
              name: 'Composite',
              className: 'AclStatus'
            }
          }
        }
      }
    };
  }
}

module.exports = AclStatusResult;
