/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Data Lake Store filesystem content summary information response.
 *
 */
class ContentSummaryResult {
  /**
   * Create a ContentSummaryResult.
   * @property {object} [contentSummary] the content summary for the specified
   * path
   * @property {number} [contentSummary.directoryCount] the number of
   * directories.
   * @property {number} [contentSummary.fileCount] the number of files.
   * @property {number} [contentSummary.length] the number of bytes used by the
   * content.
   * @property {number} [contentSummary.spaceConsumed] the disk space consumed
   * by the content.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContentSummaryResult
   *
   * @returns {object} metadata of ContentSummaryResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContentSummaryResult',
      type: {
        name: 'Composite',
        className: 'ContentSummaryResult',
        modelProperties: {
          contentSummary: {
            required: false,
            readOnly: true,
            serializedName: 'contentSummary',
            type: {
              name: 'Composite',
              className: 'ContentSummary'
            }
          }
        }
      }
    };
  }
}

module.exports = ContentSummaryResult;
