/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Detailed error information of any failure.
 *
 */
class CloudErrorBody {
  /**
   * Create a CloudErrorBody.
   * @member {string} [code] Error code string.
   * @member {string} [message] Descriptive error information.
   * @member {string} [target] Error target
   * @member {array} [details] More detailed error information.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CloudErrorBody
   *
   * @returns {object} metadata of CloudErrorBody
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CloudErrorBody',
      type: {
        name: 'Composite',
        className: 'CloudErrorBody',
        modelProperties: {
          code: {
            required: false,
            readOnly: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CloudErrorBodyElementType',
                  type: {
                    name: 'Composite',
                    className: 'CloudErrorBody'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CloudErrorBody;
