/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines the properties of a rollout.
 *
 */
class RolloutPropertiesModel {
  /**
   * Create a RolloutPropertiesModel.
   * @member {string} [status] The current status of the rollout.
   * @member {number} [totalRetryAttempts] The cardinal count of total number
   * of retries performed on the rollout at a given time.
   * @member {object} [operationInfo] Operational information of the rollout.
   * @member {number} [operationInfo.retryAttempt] The ordinal count of the
   * number of retry attempts on a rollout. 0 if no retries of the rollout have
   * been performed. If the rollout is updated with a PUT, this count is reset
   * to 0.
   * @member {boolean} [operationInfo.skipSucceededOnRetry] True, if all steps
   * that succeeded on the previous run/attempt were chosen to be skipped in
   * this retry attempt. False, otherwise.
   * @member {date} [operationInfo.startTime] The start time of the rollout in
   * UTC.
   * @member {date} [operationInfo.endTime] The start time of the rollout in
   * UTC. This property will not be set if the rollout has not completed yet.
   * @member {object} [operationInfo.error] The detailed error information for
   * any failure.
   * @member {string} [operationInfo.error.code] Error code string.
   * @member {string} [operationInfo.error.message] Descriptive error
   * information.
   * @member {string} [operationInfo.error.target] Error target
   * @member {array} [operationInfo.error.details] More detailed error
   * information.
   * @member {array} [services] The detailed information on the services being
   * deployed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RolloutPropertiesModel
   *
   * @returns {object} metadata of RolloutPropertiesModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RolloutProperties',
      type: {
        name: 'Composite',
        className: 'RolloutPropertiesModel',
        modelProperties: {
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          totalRetryAttempts: {
            required: false,
            readOnly: true,
            serializedName: 'totalRetryAttempts',
            type: {
              name: 'Number'
            }
          },
          operationInfo: {
            required: false,
            readOnly: true,
            serializedName: 'operationInfo',
            type: {
              name: 'Composite',
              className: 'RolloutOperationInfo'
            }
          },
          services: {
            required: false,
            readOnly: true,
            serializedName: 'services',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServiceElementType',
                  type: {
                    name: 'Composite',
                    className: 'Service'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RolloutPropertiesModel;
