/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The resource representation of a service topology.
 *
 * @extends models['TrackedResource']
 */
class ServiceTopologyResource extends models['TrackedResource'] {
  /**
   * Create a ServiceTopologyResource.
   * @member {string} [artifactSourceId] The resource Id of the artifact source
   * that contains the artifacts that can be referenced in the service units.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceTopologyResource
   *
   * @returns {object} metadata of ServiceTopologyResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceTopologyResource',
      type: {
        name: 'Composite',
        className: 'ServiceTopologyResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          artifactSourceId: {
            required: false,
            serializedName: 'properties.artifactSourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceTopologyResource;
