/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines the artifacts of a service unit.
 *
 */
class ServiceUnitArtifacts {
  /**
   * Create a ServiceUnitArtifacts.
   * @member {string} [templateUri] The full URI of the ARM template file with
   * the SAS token.
   * @member {string} [parametersUri] The full URI of the ARM parameters file
   * with the SAS token.
   * @member {string} [templateArtifactSourceRelativePath] The path to the ARM
   * template file relative to the artifact source.
   * @member {string} [parametersArtifactSourceRelativePath] The path to the
   * ARM parameters file relative to the artifact source.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServiceUnitArtifacts
   *
   * @returns {object} metadata of ServiceUnitArtifacts
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceUnitArtifacts',
      type: {
        name: 'Composite',
        className: 'ServiceUnitArtifacts',
        modelProperties: {
          templateUri: {
            required: false,
            serializedName: 'templateUri',
            type: {
              name: 'String'
            }
          },
          parametersUri: {
            required: false,
            serializedName: 'parametersUri',
            type: {
              name: 'String'
            }
          },
          templateArtifactSourceRelativePath: {
            required: false,
            serializedName: 'templateArtifactSourceRelativePath',
            type: {
              name: 'String'
            }
          },
          parametersArtifactSourceRelativePath: {
            required: false,
            serializedName: 'parametersArtifactSourceRelativePath',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceUnitArtifacts;
