/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Properties of an artifact source.
 *
 * @extends models['UpdateResource']
 */
class ArtifactSourceFragment extends models['UpdateResource'] {
  /**
   * Create a ArtifactSourceFragment.
   * @property {string} [displayName] The artifact source's display name.
   * @property {string} [uri] The artifact source's URI.
   * @property {string} [sourceType] The artifact source's type. Possible
   * values include: 'VsoGit', 'GitHub'
   * @property {string} [folderPath] The folder containing artifacts.
   * @property {string} [armTemplateFolderPath] The folder containing Azure
   * Resource Manager templates.
   * @property {string} [branchRef] The artifact source's branch reference.
   * @property {string} [securityToken] The security token to authenticate to
   * the artifact source.
   * @property {string} [status] Indicates if the artifact source is enabled
   * (values: Enabled, Disabled). Possible values include: 'Enabled',
   * 'Disabled'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ArtifactSourceFragment
   *
   * @returns {object} metadata of ArtifactSourceFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ArtifactSourceFragment',
      type: {
        name: 'Composite',
        className: 'ArtifactSourceFragment',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          displayName: {
            required: false,
            serializedName: 'properties.displayName',
            type: {
              name: 'String'
            }
          },
          uri: {
            required: false,
            serializedName: 'properties.uri',
            type: {
              name: 'String'
            }
          },
          sourceType: {
            required: false,
            serializedName: 'properties.sourceType',
            type: {
              name: 'String'
            }
          },
          folderPath: {
            required: false,
            serializedName: 'properties.folderPath',
            type: {
              name: 'String'
            }
          },
          armTemplateFolderPath: {
            required: false,
            serializedName: 'properties.armTemplateFolderPath',
            type: {
              name: 'String'
            }
          },
          branchRef: {
            required: false,
            serializedName: 'properties.branchRef',
            type: {
              name: 'String'
            }
          },
          securityToken: {
            required: false,
            serializedName: 'properties.securityToken',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'properties.status',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ArtifactSourceFragment;
