/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This represents the payload required to import a virtual machine from a
 * different lab into the current one
 *
 */
class ImportLabVirtualMachineRequest {
  /**
   * Create a ImportLabVirtualMachineRequest.
   * @property {string} [sourceVirtualMachineResourceId] The full resource ID
   * of the virtual machine to be imported.
   * @property {string} [destinationVirtualMachineName] The name of the virtual
   * machine in the destination lab
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImportLabVirtualMachineRequest
   *
   * @returns {object} metadata of ImportLabVirtualMachineRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImportLabVirtualMachineRequest',
      type: {
        name: 'Composite',
        className: 'ImportLabVirtualMachineRequest',
        modelProperties: {
          sourceVirtualMachineResourceId: {
            required: false,
            serializedName: 'sourceVirtualMachineResourceId',
            type: {
              name: 'String'
            }
          },
          destinationVirtualMachineName: {
            required: false,
            serializedName: 'destinationVirtualMachineName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ImportLabVirtualMachineRequest;
