/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Description of the shared access key.
 *
 */
class SharedAccessSignatureAuthorizationRuleAccessRightsDescription {
  /**
   * Create a SharedAccessSignatureAuthorizationRuleAccessRightsDescription.
   * @member {string} keyName Name of the key.
   * @member {string} [primaryKey] Primary SAS key value.
   * @member {string} [secondaryKey] Secondary SAS key value.
   * @member {string} rights Rights that this key has. Possible values include:
   * 'ServiceConfig', 'EnrollmentRead', 'EnrollmentWrite', 'DeviceConnect',
   * 'RegistrationStatusRead', 'RegistrationStatusWrite'
   */
  constructor() {
  }

  /**
   * Defines the metadata of SharedAccessSignatureAuthorizationRuleAccessRightsDescription
   *
   * @returns {object} metadata of SharedAccessSignatureAuthorizationRuleAccessRightsDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SharedAccessSignatureAuthorizationRule_AccessRightsDescription_',
      type: {
        name: 'Composite',
        className: 'SharedAccessSignatureAuthorizationRuleAccessRightsDescription',
        modelProperties: {
          keyName: {
            required: true,
            serializedName: 'keyName',
            type: {
              name: 'String'
            }
          },
          primaryKey: {
            required: false,
            serializedName: 'primaryKey',
            type: {
              name: 'String'
            }
          },
          secondaryKey: {
            required: false,
            serializedName: 'secondaryKey',
            type: {
              name: 'String'
            }
          },
          rights: {
            required: true,
            serializedName: 'rights',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SharedAccessSignatureAuthorizationRuleAccessRightsDescription;
