/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ResourceProviderOperationDisplay.
 */
class ResourceProviderOperationDisplay {
  /**
   * Create a ResourceProviderOperationDisplay.
   * @member {string} [provider] Name of the resource provider.
   * @member {string} [resource] Name of the resource type.
   * @member {string} [operation] Name of the resource provider operation.
   * @member {string} [description] Description of the resource provider
   * operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceProviderOperationDisplay
   *
   * @returns {object} metadata of ResourceProviderOperationDisplay
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceProviderOperationDisplay',
      type: {
        name: 'Composite',
        className: 'ResourceProviderOperationDisplay',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceProviderOperationDisplay;
