/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a contractual rule for link attribution.
 *
 * @extends models['ContractualRulesAttribution']
 */
class ContractualRulesLinkAttribution extends models['ContractualRulesAttribution'] {
  /**
   * Create a ContractualRulesLinkAttribution.
   * @property {string} text The attribution text.
   * @property {string} url The URL to the provider's website. Use text and URL
   * to create the hyperlink.
   * @property {boolean} [optionalForListDisplay] Indicates whether this
   * provider's attribution is optional.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ContractualRulesLinkAttribution
   *
   * @returns {object} metadata of ContractualRulesLinkAttribution
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContractualRules/LinkAttribution',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ContractualRulesContractualRule',
        className: 'ContractualRulesLinkAttribution',
        modelProperties: {
          targetPropertyName: {
            required: false,
            readOnly: true,
            serializedName: 'targetPropertyName',
            type: {
              name: 'String'
            }
          },
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          mustBeCloseToContent: {
            required: false,
            readOnly: true,
            serializedName: 'mustBeCloseToContent',
            type: {
              name: 'Boolean'
            }
          },
          text: {
            required: true,
            serializedName: 'text',
            type: {
              name: 'String'
            }
          },
          url: {
            required: true,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          optionalForListDisplay: {
            required: false,
            readOnly: true,
            serializedName: 'optionalForListDisplay',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ContractualRulesLinkAttribution;
