/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Caching settings for a caching-type route. To disable caching, do not
 * provide a cacheConfiguration object.
 *
 */
class CacheConfiguration {
  /**
   * Create a CacheConfiguration.
   * @member {string} [queryParameterStripDirective] Treatment of URL query
   * terms when forming the cache key. Possible values include: 'StripNone',
   * 'StripAll'
   * @member {string} [dynamicCompression] Whether to use dynamic compression
   * for cached content. Possible values include: 'Enabled', 'Disabled'
   */
  constructor() {
  }

  /**
   * Defines the metadata of CacheConfiguration
   *
   * @returns {object} metadata of CacheConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CacheConfiguration',
      type: {
        name: 'Composite',
        className: 'CacheConfiguration',
        modelProperties: {
          queryParameterStripDirective: {
            required: false,
            serializedName: 'queryParameterStripDirective',
            type: {
              name: 'String'
            }
          },
          dynamicCompression: {
            required: false,
            serializedName: 'dynamicCompression',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CacheConfiguration;
