/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Round-Robin load balancing settings for a backend pool
 *
 */
class LoadBalancingSettingsUpdateParameters {
  /**
   * Create a LoadBalancingSettingsUpdateParameters.
   * @member {number} [sampleSize] The number of samples to consider for load
   * balancing decisions
   * @member {number} [successfulSamplesRequired] The number of samples within
   * the sample period that must succeed
   * @member {number} [additionalLatencyMilliseconds] The additional latency in
   * milliseconds for probes to fall into the lowest latency bucket
   */
  constructor() {
  }

  /**
   * Defines the metadata of LoadBalancingSettingsUpdateParameters
   *
   * @returns {object} metadata of LoadBalancingSettingsUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LoadBalancingSettingsUpdateParameters',
      type: {
        name: 'Composite',
        className: 'LoadBalancingSettingsUpdateParameters',
        modelProperties: {
          sampleSize: {
            required: false,
            serializedName: 'sampleSize',
            type: {
              name: 'Number'
            }
          },
          successfulSamplesRequired: {
            required: false,
            serializedName: 'successfulSamplesRequired',
            type: {
              name: 'Number'
            }
          },
          additionalLatencyMilliseconds: {
            required: false,
            serializedName: 'additionalLatencyMilliseconds',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = LoadBalancingSettingsUpdateParameters;
