/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * DirectoryObject list operation result.
 */
class DirectoryObjectListResult extends Array {
  /**
   * Create a DirectoryObjectListResult.
   * @member {string} [odatanextLink] The URL to get the next set of results.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DirectoryObjectListResult
   *
   * @returns {object} metadata of DirectoryObjectListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DirectoryObjectListResult',
      type: {
        name: 'Composite',
        className: 'DirectoryObjectListResult',
        modelProperties: {
          value: {
            required: false,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DirectoryObjectElementType',
                  type: {
                    name: 'Composite',
                    additionalProperties: {
                      type: {
                        name: 'Dictionary',
                        value: {
                            required: false,
                            serializedName: 'ObjectElementType',
                            type: {
                              name: 'Object'
                            }
                        }
                      }
                    },
                    polymorphicDiscriminator: {
                      serializedName: 'objectType',
                      clientName: 'objectType'
                    },
                    uberParent: 'DirectoryObject',
                    className: 'DirectoryObject'
                  }
              }
            }
          },
          odatanextLink: {
            required: false,
            serializedName: 'odata\\.nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DirectoryObjectListResult;
