/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The health data for an endpoint
 *
 */
class EndpointHealthData {
  /**
   * Create a EndpointHealthData.
   * @member {string} [endpointId] Id of the endpoint
   * @member {string} [healthStatus] Health status. Possible values include:
   * 'unknown', 'healthy', 'unhealthy', 'dead'
   */
  constructor() {
  }

  /**
   * Defines the metadata of EndpointHealthData
   *
   * @returns {object} metadata of EndpointHealthData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EndpointHealthData',
      type: {
        name: 'Composite',
        className: 'EndpointHealthData',
        modelProperties: {
          endpointId: {
            required: false,
            serializedName: 'endpointId',
            type: {
              name: 'String'
            }
          },
          healthStatus: {
            required: false,
            serializedName: 'healthStatus',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EndpointHealthData;
