/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Compilation error when evaluating route
 *
 */
class RouteCompilationError {
  /**
   * Create a RouteCompilationError.
   * @member {string} [message] Route error message
   * @member {string} [severity] Severity of the route error. Possible values
   * include: 'error', 'warning'
   * @member {object} [location] Location where the route error happened
   * @member {object} [location.start] Start where the route error happened
   * @member {number} [location.start.line] Line where the route error happened
   * @member {number} [location.start.column] Column where the route error
   * happened
   * @member {object} [location.end] End where the route error happened
   * @member {number} [location.end.line] Line where the route error happened
   * @member {number} [location.end.column] Column where the route error
   * happened
   */
  constructor() {
  }

  /**
   * Defines the metadata of RouteCompilationError
   *
   * @returns {object} metadata of RouteCompilationError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RouteCompilationError',
      type: {
        name: 'Composite',
        className: 'RouteCompilationError',
        modelProperties: {
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          severity: {
            required: false,
            serializedName: 'severity',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'Composite',
              className: 'RouteErrorRange'
            }
          }
        }
      }
    };
  }
}

module.exports = RouteCompilationError;
