/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Result of testing one route
 *
 */
class TestRouteResult {
  /**
   * Create a TestRouteResult.
   * @member {string} [result] Result of testing route. Possible values
   * include: 'undefined', 'false', 'true'
   * @member {object} [details] Detailed result of testing route
   * @member {array} [details.compilationErrors] JSON-serialized list of route
   * compilation errors
   */
  constructor() {
  }

  /**
   * Defines the metadata of TestRouteResult
   *
   * @returns {object} metadata of TestRouteResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TestRouteResult',
      type: {
        name: 'Composite',
        className: 'TestRouteResult',
        modelProperties: {
          result: {
            required: false,
            serializedName: 'result',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Composite',
              className: 'TestRouteResultDetails'
            }
          }
        }
      }
    };
  }
}

module.exports = TestRouteResult;
