/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure resource SKU definition.
 *
 */
class AzureResourceSku {
  /**
   * Create a AzureResourceSku.
   * @property {string} [resourceType] Resource Namespace and Type.
   * @property {object} [sku] The SKU details.
   * @property {string} [sku.name] SKU name. Possible values include: 'D13_v2',
   * 'D14_v2', 'L8', 'L16', 'D11_v2', 'D12_v2', 'L4'
   * @property {number} [sku.capacity] SKU capacity.
   * @property {object} [capacity] The SKU capacity.
   * @property {string} [capacity.scaleType] Scale type. Possible values
   * include: 'automatic', 'manual', 'none'
   * @property {number} [capacity.minimum] Minimum allowed capacity.
   * @property {number} [capacity.maximum] Maximum allowed capacity.
   * @property {number} [capacity.default] The default capacity that would be
   * used.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureResourceSku
   *
   * @returns {object} metadata of AzureResourceSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureResourceSku',
      type: {
        name: 'Composite',
        className: 'AzureResourceSku',
        modelProperties: {
          resourceType: {
            required: false,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'AzureSku'
            }
          },
          capacity: {
            required: false,
            serializedName: 'capacity',
            type: {
              name: 'Composite',
              className: 'AzureCapacity'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureResourceSku;
