/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The result returned from a check name availability request.
 *
 */
class CheckNameResult {
  /**
   * Create a CheckNameResult.
   * @property {boolean} [nameAvailable] Specifies a Boolean value that
   * indicates if the name is available.
   * @property {string} [name] The name that was checked.
   * @property {string} [message] Message indicating an unavailable name due to
   * a conflict, or a description of the naming rules that are violated.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CheckNameResult
   *
   * @returns {object} metadata of CheckNameResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CheckNameResult',
      type: {
        name: 'Composite',
        className: 'CheckNameResult',
        modelProperties: {
          nameAvailable: {
            required: false,
            serializedName: 'nameAvailable',
            type: {
              name: 'Boolean'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CheckNameResult;
