/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties for creating a managed lab and a default environment setting
 *
 */
class CreateLabProperties {
  /**
   * Create a CreateLabProperties.
   * @property {object} [environmentSettingCreationParameters] Settings related
   * to creating an environment setting
   * @property {object}
   * [environmentSettingCreationParameters.resourceSettingCreationParameters]
   * The resource specific settings
   * @property {string}
   * [environmentSettingCreationParameters.resourceSettingCreationParameters.location]
   * The location where the virtual machine will live
   * @property {string}
   * [environmentSettingCreationParameters.resourceSettingCreationParameters.name]
   * The name of the resource setting
   * @property {string}
   * [environmentSettingCreationParameters.resourceSettingCreationParameters.galleryImageResourceId]
   * The resource id of the gallery image used for creating the virtual machine
   * @property {string}
   * [environmentSettingCreationParameters.resourceSettingCreationParameters.size]
   * The size of the virtual machine. Possible values include: 'Basic',
   * 'Standard', 'Performance'
   * @property {object}
   * [environmentSettingCreationParameters.resourceSettingCreationParameters.referenceVmCreationParameters]
   * Creation parameters for Reference Vm
   * @property {string}
   * [environmentSettingCreationParameters.resourceSettingCreationParameters.referenceVmCreationParameters.userName]
   * The username of the virtual machine
   * @property {string}
   * [environmentSettingCreationParameters.resourceSettingCreationParameters.referenceVmCreationParameters.password]
   * The password of the virtual machine.
   * @property {object} labCreationParameters Settings related to creating a
   * lab
   * @property {number} [labCreationParameters.maxUsersInLab] Maximum number of
   * users allowed in the lab.
   * @property {string} name The name of the resource
   * @property {string} [location] The location of the resource
   * @property {object} [tags] The tags of the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateLabProperties
   *
   * @returns {object} metadata of CreateLabProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateLabProperties',
      type: {
        name: 'Composite',
        className: 'CreateLabProperties',
        modelProperties: {
          environmentSettingCreationParameters: {
            required: false,
            serializedName: 'environmentSettingCreationParameters',
            type: {
              name: 'Composite',
              className: 'EnvironmentSettingCreationParameters'
            }
          },
          labCreationParameters: {
            required: true,
            serializedName: 'labCreationParameters',
            type: {
              name: 'Composite',
              className: 'LabCreationParameters'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CreateLabProperties;
