/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The REST API operation supported by ManagedLab ResourceProvider.
 *
 */
class OperationMetadata {
  /**
   * Create a OperationMetadata.
   * @property {string} [name] Operation name:
   * {provider}/{resource}/{operation}
   * @property {object} [display] The object that describes the operations
   * @property {string} [display.provider] Friendly name of the resource
   * provider
   * @property {string} [display.resource] Resource type on which the operation
   * is performed.
   * @property {string} [display.operation] Operation type: read, write,
   * delete, listKeys/action, etc.
   * @property {string} [display.description] Friendly name of the operation
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationMetadata
   *
   * @returns {object} metadata of OperationMetadata
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationMetadata',
      type: {
        name: 'Composite',
        className: 'OperationMetadata',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationMetadataDisplay'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationMetadata;
