/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents the size configuration under the lab account
 *
 */
class SizeConfigurationProperties {
  /**
   * Create a SizeConfigurationProperties.
   * @property {array} [environmentSizes] Represents a list of size categories
   * supported by this Lab Account (Small, Medium, Large)
   */
  constructor() {
  }

  /**
   * Defines the metadata of SizeConfigurationProperties
   *
   * @returns {object} metadata of SizeConfigurationProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SizeConfigurationProperties',
      type: {
        name: 'Composite',
        className: 'SizeConfigurationProperties',
        modelProperties: {
          environmentSizes: {
            required: false,
            serializedName: 'environmentSizes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EnvironmentSizeElementType',
                  type: {
                    name: 'Composite',
                    className: 'EnvironmentSize'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SizeConfigurationProperties;
