/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An Azure resource which represents access to a suite of Location Based
 * Services REST APIs.
 *
 * @extends models['Resource']
 */
class LocationBasedServicesAccount extends models['Resource'] {
  /**
   * Create a LocationBasedServicesAccount.
   * @member {string} [location] The location of the resource.
   * @member {object} [tags] Gets a list of key value pairs that describe the
   * resource. These tags can be used in viewing and grouping this resource
   * (across resource groups). A maximum of 15 tags can be provided for a
   * resource. Each tag must have a key no greater than 128 characters and
   * value no greater than 256 characters.
   * @member {object} [sku] The SKU of this account.
   * @member {string} [sku.name] The name of the SKU, in standard format (such
   * as S0).
   * @member {string} [sku.tier] Gets the sku tier. This is based on the SKU
   * name.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LocationBasedServicesAccount
   *
   * @returns {object} metadata of LocationBasedServicesAccount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LocationBasedServicesAccount',
      type: {
        name: 'Composite',
        className: 'LocationBasedServicesAccount',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            readOnly: true,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          sku: {
            required: false,
            readOnly: true,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'Sku'
            }
          }
        }
      }
    };
  }
}

module.exports = LocationBasedServicesAccount;
