/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The set of keys which can be used to access the Location Based Services REST
 * APIs. Two keys are provided for key rotation without interruption.
 *
 */
class LocationBasedServicesAccountKeys {
  /**
   * Create a LocationBasedServicesAccountKeys.
   * @member {string} [id] The full Azure resource identifier of the Location
   * Based Services Account.
   * @member {string} [primaryKey] The primary key for accessing the Location
   * Based Services REST APIs.
   * @member {string} [secondaryKey] The secondary key for accessing the
   * Location Based Services REST APIs.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LocationBasedServicesAccountKeys
   *
   * @returns {object} metadata of LocationBasedServicesAccountKeys
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LocationBasedServicesAccountKeys',
      type: {
        name: 'Composite',
        className: 'LocationBasedServicesAccountKeys',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          primaryKey: {
            required: false,
            readOnly: true,
            serializedName: 'primaryKey',
            type: {
              name: 'String'
            }
          },
          secondaryKey: {
            required: false,
            readOnly: true,
            serializedName: 'secondaryKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LocationBasedServicesAccountKeys;
