/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary A query response table.
  *
 * Contains the columns and rows for one table in a query response.
 *
 */
class Table {
  /**
   * Create a Table.
   * @member {string} name The name of the table.
   * @member {array} columns The list of columns in this table.
   * @member {array} rows The resulting rows from this query.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Table
   *
   * @returns {object} metadata of Table
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'table',
      type: {
        name: 'Composite',
        className: 'Table',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          columns: {
            required: true,
            serializedName: 'columns',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ColumnElementType',
                  type: {
                    name: 'Composite',
                    className: 'Column'
                  }
              }
            }
          },
          rows: {
            required: true,
            serializedName: 'rows',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ArrayElementType',
                  type: {
                    name: 'Sequence',
                    element: {
                        required: false,
                        serializedName: 'StringElementType',
                        type: {
                          name: 'String'
                        }
                    }
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Table;
