/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The AS2 agreement mdn settings.
 *
 */
class AS2MdnSettings {
  /**
   * Create a AS2MdnSettings.
   * @property {boolean} needMDN The value indicating whether to send or
   * request a MDN.
   * @property {boolean} signMDN The value indicating whether the MDN needs to
   * be signed or not.
   * @property {boolean} sendMDNAsynchronously The value indicating whether to
   * send the asynchronous MDN.
   * @property {string} [receiptDeliveryUrl] The receipt delivery URL.
   * @property {string} [dispositionNotificationTo] The disposition
   * notification to header value.
   * @property {boolean} signOutboundMDNIfOptional The value indicating whether
   * to sign the outbound MDN if optional.
   * @property {string} [mdnText] The MDN text.
   * @property {boolean} sendInboundMDNToMessageBox The value indicating
   * whether to send inbound MDN to message box.
   * @property {string} micHashingAlgorithm The signing or hashing algorithm.
   * Possible values include: 'NotSpecified', 'None', 'MD5', 'SHA1', 'SHA2256',
   * 'SHA2384', 'SHA2512'
   */
  constructor() {
  }

  /**
   * Defines the metadata of AS2MdnSettings
   *
   * @returns {object} metadata of AS2MdnSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AS2MdnSettings',
      type: {
        name: 'Composite',
        className: 'AS2MdnSettings',
        modelProperties: {
          needMDN: {
            required: true,
            serializedName: 'needMDN',
            type: {
              name: 'Boolean'
            }
          },
          signMDN: {
            required: true,
            serializedName: 'signMDN',
            type: {
              name: 'Boolean'
            }
          },
          sendMDNAsynchronously: {
            required: true,
            serializedName: 'sendMDNAsynchronously',
            type: {
              name: 'Boolean'
            }
          },
          receiptDeliveryUrl: {
            required: false,
            serializedName: 'receiptDeliveryUrl',
            type: {
              name: 'String'
            }
          },
          dispositionNotificationTo: {
            required: false,
            serializedName: 'dispositionNotificationTo',
            type: {
              name: 'String'
            }
          },
          signOutboundMDNIfOptional: {
            required: true,
            serializedName: 'signOutboundMDNIfOptional',
            type: {
              name: 'Boolean'
            }
          },
          mdnText: {
            required: false,
            serializedName: 'mdnText',
            type: {
              name: 'String'
            }
          },
          sendInboundMDNToMessageBox: {
            required: true,
            serializedName: 'sendInboundMDNToMessageBox',
            type: {
              name: 'Boolean'
            }
          },
          micHashingAlgorithm: {
            required: true,
            serializedName: 'micHashingAlgorithm',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AS2MdnSettings;
