/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The AS2 agreement security settings.
 *
 */
class AS2SecuritySettings {
  /**
   * Create a AS2SecuritySettings.
   * @property {boolean} overrideGroupSigningCertificate The value indicating
   * whether to send or request a MDN.
   * @property {string} [signingCertificateName] The name of the signing
   * certificate.
   * @property {string} [encryptionCertificateName] The name of the encryption
   * certificate.
   * @property {boolean} enableNRRForInboundEncodedMessages The value
   * indicating whether to enable NRR for inbound encoded messages.
   * @property {boolean} enableNRRForInboundDecodedMessages The value
   * indicating whether to enable NRR for inbound decoded messages.
   * @property {boolean} enableNRRForOutboundMDN The value indicating whether
   * to enable NRR for outbound MDN.
   * @property {boolean} enableNRRForOutboundEncodedMessages The value
   * indicating whether to enable NRR for outbound encoded messages.
   * @property {boolean} enableNRRForOutboundDecodedMessages The value
   * indicating whether to enable NRR for outbound decoded messages.
   * @property {boolean} enableNRRForInboundMDN The value indicating whether to
   * enable NRR for inbound MDN.
   * @property {string} [sha2AlgorithmFormat] The Sha2 algorithm format. Valid
   * values are Sha2, ShaHashSize, ShaHyphenHashSize, Sha2UnderscoreHashSize.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AS2SecuritySettings
   *
   * @returns {object} metadata of AS2SecuritySettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AS2SecuritySettings',
      type: {
        name: 'Composite',
        className: 'AS2SecuritySettings',
        modelProperties: {
          overrideGroupSigningCertificate: {
            required: true,
            serializedName: 'overrideGroupSigningCertificate',
            type: {
              name: 'Boolean'
            }
          },
          signingCertificateName: {
            required: false,
            serializedName: 'signingCertificateName',
            type: {
              name: 'String'
            }
          },
          encryptionCertificateName: {
            required: false,
            serializedName: 'encryptionCertificateName',
            type: {
              name: 'String'
            }
          },
          enableNRRForInboundEncodedMessages: {
            required: true,
            serializedName: 'enableNRRForInboundEncodedMessages',
            type: {
              name: 'Boolean'
            }
          },
          enableNRRForInboundDecodedMessages: {
            required: true,
            serializedName: 'enableNRRForInboundDecodedMessages',
            type: {
              name: 'Boolean'
            }
          },
          enableNRRForOutboundMDN: {
            required: true,
            serializedName: 'enableNRRForOutboundMDN',
            type: {
              name: 'Boolean'
            }
          },
          enableNRRForOutboundEncodedMessages: {
            required: true,
            serializedName: 'enableNRRForOutboundEncodedMessages',
            type: {
              name: 'Boolean'
            }
          },
          enableNRRForOutboundDecodedMessages: {
            required: true,
            serializedName: 'enableNRRForOutboundDecodedMessages',
            type: {
              name: 'Boolean'
            }
          },
          enableNRRForInboundMDN: {
            required: true,
            serializedName: 'enableNRRForInboundMDN',
            type: {
              name: 'Boolean'
            }
          },
          sha2AlgorithmFormat: {
            required: false,
            serializedName: 'sha2AlgorithmFormat',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AS2SecuritySettings;
