/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The assembly properties definition.
 *
 * @extends models['ArtifactContentPropertiesDefinition']
 */
class AssemblyProperties extends models['ArtifactContentPropertiesDefinition'] {
  /**
   * Create a AssemblyProperties.
   * @property {string} assemblyName The assembly name.
   * @property {string} [assemblyVersion] The assembly version.
   * @property {string} [assemblyCulture] The assembly culture.
   * @property {string} [assemblyPublicKeyToken] The assembly public key token.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AssemblyProperties
   *
   * @returns {object} metadata of AssemblyProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AssemblyProperties',
      type: {
        name: 'Composite',
        className: 'AssemblyProperties',
        modelProperties: {
          createdTime: {
            required: false,
            serializedName: 'createdTime',
            type: {
              name: 'DateTime'
            }
          },
          changedTime: {
            required: false,
            serializedName: 'changedTime',
            type: {
              name: 'DateTime'
            }
          },
          metadata: {
            required: false,
            serializedName: 'metadata',
            type: {
              name: 'Object'
            }
          },
          content: {
            required: false,
            serializedName: 'content',
            type: {
              name: 'Object'
            }
          },
          contentType: {
            required: false,
            serializedName: 'contentType',
            type: {
              name: 'String'
            }
          },
          contentLink: {
            required: false,
            serializedName: 'contentLink',
            type: {
              name: 'Composite',
              className: 'ContentLink'
            }
          },
          assemblyName: {
            required: true,
            serializedName: 'assemblyName',
            type: {
              name: 'String'
            }
          },
          assemblyVersion: {
            required: false,
            serializedName: 'assemblyVersion',
            type: {
              name: 'String'
            }
          },
          assemblyCulture: {
            required: false,
            serializedName: 'assemblyCulture',
            type: {
              name: 'String'
            }
          },
          assemblyPublicKeyToken: {
            required: false,
            serializedName: 'assemblyPublicKeyToken',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AssemblyProperties;
