/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The X12 delimiter override settings.
 *
 */
class X12DelimiterOverrides {
  /**
   * Create a X12DelimiterOverrides.
   * @property {string} [protocolVersion] The protocol version.
   * @property {string} [messageId] The message id.
   * @property {number} dataElementSeparator The data element separator.
   * @property {number} componentSeparator The component separator.
   * @property {number} segmentTerminator The segment terminator.
   * @property {string} segmentTerminatorSuffix The segment terminator suffix.
   * Possible values include: 'NotSpecified', 'None', 'CR', 'LF', 'CRLF'
   * @property {number} replaceCharacter The replacement character.
   * @property {boolean} replaceSeparatorsInPayload The value indicating
   * whether to replace separators in payload.
   * @property {string} [targetNamespace] The target namespace on which this
   * delimiter settings has to be applied.
   */
  constructor() {
  }

  /**
   * Defines the metadata of X12DelimiterOverrides
   *
   * @returns {object} metadata of X12DelimiterOverrides
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'X12DelimiterOverrides',
      type: {
        name: 'Composite',
        className: 'X12DelimiterOverrides',
        modelProperties: {
          protocolVersion: {
            required: false,
            serializedName: 'protocolVersion',
            type: {
              name: 'String'
            }
          },
          messageId: {
            required: false,
            serializedName: 'messageId',
            type: {
              name: 'String'
            }
          },
          dataElementSeparator: {
            required: true,
            serializedName: 'dataElementSeparator',
            type: {
              name: 'Number'
            }
          },
          componentSeparator: {
            required: true,
            serializedName: 'componentSeparator',
            type: {
              name: 'Number'
            }
          },
          segmentTerminator: {
            required: true,
            serializedName: 'segmentTerminator',
            type: {
              name: 'Number'
            }
          },
          segmentTerminatorSuffix: {
            required: true,
            serializedName: 'segmentTerminatorSuffix',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'None', 'CR', 'LF', 'CRLF' ]
            }
          },
          replaceCharacter: {
            required: true,
            serializedName: 'replaceCharacter',
            type: {
              name: 'Number'
            }
          },
          replaceSeparatorsInPayload: {
            required: true,
            serializedName: 'replaceSeparatorsInPayload',
            type: {
              name: 'Boolean'
            }
          },
          targetNamespace: {
            required: false,
            serializedName: 'targetNamespace',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = X12DelimiterOverrides;
