/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a ProductionOrStagingEndpointInfo.
 * @extends models['EndpointInfo']
 */
class ProductionOrStagingEndpointInfo extends models['EndpointInfo'] {
  /**
   * Create a ProductionOrStagingEndpointInfo.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ProductionOrStagingEndpointInfo
   *
   * @returns {object} metadata of ProductionOrStagingEndpointInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProductionOrStagingEndpointInfo',
      type: {
        name: 'Composite',
        className: 'ProductionOrStagingEndpointInfo',
        modelProperties: {
          versionId: {
            required: false,
            serializedName: 'versionId',
            type: {
              name: 'String'
            }
          },
          isStaging: {
            required: false,
            serializedName: 'isStaging',
            type: {
              name: 'Boolean'
            }
          },
          endpointUrl: {
            required: false,
            serializedName: 'endpointUrl',
            type: {
              name: 'String'
            }
          },
          region: {
            required: false,
            serializedName: 'region',
            type: {
              name: 'String'
            }
          },
          assignedEndpointKey: {
            required: false,
            serializedName: 'assignedEndpointKey',
            type: {
              name: 'String'
            }
          },
          endpointRegion: {
            required: false,
            serializedName: 'endpointRegion',
            type: {
              name: 'String'
            }
          },
          failedRegions: {
            required: false,
            serializedName: 'failedRegions',
            type: {
              name: 'String'
            }
          },
          publishedDateTime: {
            required: false,
            serializedName: 'publishedDateTime',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ProductionOrStagingEndpointInfo;
