/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The application publish settings.
 *
 */
class PublishSettings {
  /**
   * Create a PublishSettings.
   * @property {uuid} id The application ID.
   * @property {boolean} isSentimentAnalysisEnabled Setting sentiment analysis
   * as true returns the Sentiment of the input utterance along with the
   * response
   * @property {boolean} isSpeechEnabled Setting speech as public enables
   * speech priming in your app
   * @property {boolean} isSpellCheckerEnabled Setting spell checker as public
   * enables spell checking the input utterance.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PublishSettings
   *
   * @returns {object} metadata of PublishSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PublishSettings',
      type: {
        name: 'Composite',
        className: 'PublishSettings',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          isSentimentAnalysisEnabled: {
            required: true,
            nullable: false,
            serializedName: 'sentimentAnalysis',
            type: {
              name: 'Boolean'
            }
          },
          isSpeechEnabled: {
            required: true,
            nullable: false,
            serializedName: 'speech',
            type: {
              name: 'Boolean'
            }
          },
          isSpellCheckerEnabled: {
            required: true,
            nullable: false,
            serializedName: 'spellChecker',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = PublishSettings;
