/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * AKS properties
 *
 */
class AKSProperties {
  /**
   * Create a AKSProperties.
   * @member {string} [clusterFqdn] Cluster full qualified domain name
   * @member {array} [systemServices] System services
   * @member {number} [agentCount] Number of agents
   * @member {string} [agentVMSize] Agent virtual machine size
   * @member {object} [sslConfiguration] SSL configuration
   * @member {string} [sslConfiguration.status] Enable or disable ssl for
   * scoring. Possible values include: 'Disabled', 'Enabled'
   * @member {string} [sslConfiguration.cert] Cert data
   * @member {string} [sslConfiguration.key] Key data
   * @member {string} [sslConfiguration.cname] CNAME of the cert
   */
  constructor() {
  }

  /**
   * Defines the metadata of AKSProperties
   *
   * @returns {object} metadata of AKSProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AKS_properties',
      type: {
        name: 'Composite',
        className: 'AKSProperties',
        modelProperties: {
          clusterFqdn: {
            required: false,
            serializedName: 'clusterFqdn',
            type: {
              name: 'String'
            }
          },
          systemServices: {
            required: false,
            serializedName: 'systemServices',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SystemServiceElementType',
                  type: {
                    name: 'Composite',
                    className: 'SystemService'
                  }
              }
            }
          },
          agentCount: {
            required: false,
            serializedName: 'agentCount',
            constraints: {
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          },
          agentVMSize: {
            required: false,
            serializedName: 'agentVMSize',
            type: {
              name: 'String'
            }
          },
          sslConfiguration: {
            required: false,
            serializedName: 'sslConfiguration',
            type: {
              name: 'Composite',
              className: 'SslConfiguration'
            }
          }
        }
      }
    };
  }
}

module.exports = AKSProperties;
