/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a VirtualMachineProperties.
 */
class VirtualMachineProperties {
  /**
   * Create a VirtualMachineProperties.
   * @member {string} [virtualMachineSize] Virtual Machine size
   * @member {number} [sshPort] Port open for ssh connections.
   * @member {string} [address] Public IP address of the virtual machine.
   * @member {object} [administratorAccount] Admin credentials for virtual
   * machine
   * @member {string} [administratorAccount.username] Username of admin account
   * @member {string} [administratorAccount.password] Password of admin account
   * @member {string} [administratorAccount.publicKeyData] Public key data
   * @member {string} [administratorAccount.privateKeyData] Private key data
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineProperties
   *
   * @returns {object} metadata of VirtualMachineProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachine_properties',
      type: {
        name: 'Composite',
        className: 'VirtualMachineProperties',
        modelProperties: {
          virtualMachineSize: {
            required: false,
            serializedName: 'virtualMachineSize',
            type: {
              name: 'String'
            }
          },
          sshPort: {
            required: false,
            serializedName: 'sshPort',
            type: {
              name: 'Number'
            }
          },
          address: {
            required: false,
            serializedName: 'address',
            type: {
              name: 'String'
            }
          },
          administratorAccount: {
            required: false,
            serializedName: 'administratorAccount',
            type: {
              name: 'Composite',
              className: 'VirtualMachineSshCredentials'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineProperties;
