/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Asset File Storage encryption metadata.
 *
 */
class AssetFileEncryptionMetadata {
  /**
   * Create a AssetFileEncryptionMetadata.
   * @property {string} [initializationVector] The Asset File initialization
   * vector.
   * @property {string} [assetFileName] The Asset File name.
   * @property {uuid} assetFileId The Asset File Id.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AssetFileEncryptionMetadata
   *
   * @returns {object} metadata of AssetFileEncryptionMetadata
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AssetFileEncryptionMetadata',
      type: {
        name: 'Composite',
        className: 'AssetFileEncryptionMetadata',
        modelProperties: {
          initializationVector: {
            required: false,
            serializedName: 'initializationVector',
            type: {
              name: 'String'
            }
          },
          assetFileName: {
            required: false,
            serializedName: 'assetFileName',
            type: {
              name: 'String'
            }
          },
          assetFileId: {
            required: true,
            serializedName: 'assetFileId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AssetFileEncryptionMetadata;
