/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class for CommonEncryptionCbcs encryption scheme
 *
 */
class CommonEncryptionCbcs {
  /**
   * Create a CommonEncryptionCbcs.
   * @property {object} [enabledProtocols] Representing supported protocols
   * @property {boolean} [enabledProtocols.download] Enable Download protocol
   * or not
   * @property {boolean} [enabledProtocols.dash] Enable DASH protocol or not
   * @property {boolean} [enabledProtocols.hls] Enable HLS protocol or not
   * @property {boolean} [enabledProtocols.smoothStreaming] Enable
   * SmoothStreaming protocol or not
   * @property {array} [clearTracks] Representing which tracks should not be
   * encrypted
   * @property {object} [contentKeys] Representing default content key for each
   * encryption scheme and separate content keys for specific tracks
   * @property {object} [contentKeys.defaultKey] Default content key for an
   * encryption scheme
   * @property {string} [contentKeys.defaultKey.label] Label can be used to
   * specify Content Key when creating a Streaming Locator
   * @property {string} [contentKeys.defaultKey.policyName] Policy used by
   * Default Key
   * @property {array} [contentKeys.keyToTrackMappings] Representing tracks
   * needs separate content key
   * @property {object} [drm] Configuration of DRMs for current encryption
   * scheme
   * @property {object} [drm.fairPlay] FairPlay configurations
   * @property {string} [drm.fairPlay.customLicenseAcquisitionUrlTemplate]
   * Template for the URL of the custom service delivering licenses to end user
   * players.  Not required when using Azure Media Services for issuing
   * licenses.  The template supports replaceable tokens that the service will
   * update at runtime with the value specific to the request.  The currently
   * supported token values are {AlternativeMediaId}, which is replaced with
   * the value of StreamingLocatorId.AlternativeMediaId, and {ContentKeyId},
   * which is replaced with the value of identifier of the key being requested.
   * @property {boolean} [drm.fairPlay.allowPersistentLicense] All license to
   * be persistent or not
   * @property {object} [drm.playReady] PlayReady configurations
   * @property {string} [drm.playReady.customLicenseAcquisitionUrlTemplate]
   * Template for the URL of the custom service delivering licenses to end user
   * players.  Not required when using Azure Media Services for issuing
   * licenses.  The template supports replaceable tokens that the service will
   * update at runtime with the value specific to the request.  The currently
   * supported token values are {AlternativeMediaId}, which is replaced with
   * the value of StreamingLocatorId.AlternativeMediaId, and {ContentKeyId},
   * which is replaced with the value of identifier of the key being requested.
   * @property {string} [drm.playReady.playReadyCustomAttributes] Custom
   * attributes for PlayReady
   * @property {object} [drm.widevine] Widevine configurations
   * @property {string} [drm.widevine.customLicenseAcquisitionUrlTemplate]
   * Template for the URL of the custom service delivering licenses to end user
   * players.  Not required when using Azure Media Services for issuing
   * licenses.  The template supports replaceable tokens that the service will
   * update at runtime with the value specific to the request.  The currently
   * supported token values are {AlternativeMediaId}, which is replaced with
   * the value of StreamingLocatorId.AlternativeMediaId, and {ContentKeyId},
   * which is replaced with the value of identifier of the key being requested.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CommonEncryptionCbcs
   *
   * @returns {object} metadata of CommonEncryptionCbcs
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CommonEncryptionCbcs',
      type: {
        name: 'Composite',
        className: 'CommonEncryptionCbcs',
        modelProperties: {
          enabledProtocols: {
            required: false,
            serializedName: 'enabledProtocols',
            type: {
              name: 'Composite',
              className: 'EnabledProtocols'
            }
          },
          clearTracks: {
            required: false,
            serializedName: 'clearTracks',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TrackSelectionElementType',
                  type: {
                    name: 'Composite',
                    className: 'TrackSelection'
                  }
              }
            }
          },
          contentKeys: {
            required: false,
            serializedName: 'contentKeys',
            type: {
              name: 'Composite',
              className: 'StreamingPolicyContentKeys'
            }
          },
          drm: {
            required: false,
            serializedName: 'drm',
            type: {
              name: 'Composite',
              className: 'CbcsDrmConfiguration'
            }
          }
        }
      }
    };
  }
}

module.exports = CommonEncryptionCbcs;
