/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents input files for a Job.
 *
 * @extends models['JobInput']
 */
class JobInputClip extends models['JobInput'] {
  /**
   * Create a JobInputClip.
   * @property {array} [files] List of files. Required for JobInputHttp.
   * Maximum of 4000 characters each.
   * @property {string} [label] A label that is assigned to a JobInputClip,
   * that is used to satisfy a reference used in the Transform. For example, a
   * Transform can be authored so as to take an image file with the label 'xyz'
   * and apply it as an overlay onto the input video before it is encoded. When
   * submitting a Job, exactly one of the JobInputs should be the image file,
   * and it should have the label 'xyz'.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of JobInputClip
   *
   * @returns {object} metadata of JobInputClip
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Media.JobInputClip',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '@odata.type',
          clientName: 'odatatype'
        },
        uberParent: 'JobInput',
        className: 'JobInputClip',
        modelProperties: {
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          files: {
            required: false,
            serializedName: 'files',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobInputClip;
