/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes a list of inputs to a Job.
 *
 * @extends models['JobInput']
 */
class JobInputs extends models['JobInput'] {
  /**
   * Create a JobInputs.
   * @property {array} [inputs] List of inputs to a Job.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of JobInputs
   *
   * @returns {object} metadata of JobInputs
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Media.JobInputs',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '@odata.type',
          clientName: 'odatatype'
        },
        uberParent: 'JobInput',
        className: 'JobInputs',
        modelProperties: {
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          inputs: {
            required: false,
            serializedName: 'inputs',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'JobInputElementType',
                  type: {
                    name: 'Composite',
                    polymorphicDiscriminator: {
                      serializedName: '@odata.type',
                      clientName: 'odatatype'
                    },
                    uberParent: 'JobInput',
                    className: 'JobInput'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = JobInputs;
