/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the properties of a rectangular window applied to the input media
 * before processing it.
 *
 */
class Rectangle {
  /**
   * Create a Rectangle.
   * @property {string} [left] The number of pixels from the left-margin. This
   * can be absolute pixel value (e.g 100), or relative to the size of the
   * video (For example, 50%).
   * @property {string} [top] The number of pixels from the top-margin. This
   * can be absolute pixel value (e.g 100), or relative to the size of the
   * video (For example, 50%).
   * @property {string} [width] The width of the rectangular region in pixels.
   * This can be absolute pixel value (e.g 100), or relative to the size of the
   * video (For example, 50%).
   * @property {string} [height] The height of the rectangular region in
   * pixels. This can be absolute pixel value (e.g 100), or relative to the
   * size of the video (For example, 50%).
   */
  constructor() {
  }

  /**
   * Defines the metadata of Rectangle
   *
   * @returns {object} metadata of Rectangle
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Rectangle',
      type: {
        name: 'Composite',
        className: 'Rectangle',
        modelProperties: {
          left: {
            required: false,
            serializedName: 'left',
            type: {
              name: 'String'
            }
          },
          top: {
            required: false,
            serializedName: 'top',
            type: {
              name: 'String'
            }
          },
          width: {
            required: false,
            serializedName: 'width',
            type: {
              name: 'String'
            }
          },
          height: {
            required: false,
            serializedName: 'height',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Rectangle;
