/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class for content key in Streaming Locator
 *
 */
class StreamingLocatorContentKey {
  /**
   * Create a StreamingLocatorContentKey.
   * @property {uuid} id ID of Content Key
   * @property {string} [type] Encryption type of Content Key. Possible values
   * include: 'CommonEncryptionCenc', 'CommonEncryptionCbcs',
   * 'EnvelopeEncryption'
   * @property {string} [labelReferenceInStreamingPolicy] Label of Content Key
   * as specified in the Streaming Policy
   * @property {string} [value] Value of Content Key
   * @property {string} [policyName] ContentKeyPolicy used by Content Key
   * @property {array} [tracks] Tracks which use this Content Key
   */
  constructor() {
  }

  /**
   * Defines the metadata of StreamingLocatorContentKey
   *
   * @returns {object} metadata of StreamingLocatorContentKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StreamingLocatorContentKey',
      type: {
        name: 'Composite',
        className: 'StreamingLocatorContentKey',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          labelReferenceInStreamingPolicy: {
            required: false,
            serializedName: 'labelReferenceInStreamingPolicy',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          policyName: {
            required: false,
            readOnly: true,
            serializedName: 'policyName',
            type: {
              name: 'String'
            }
          },
          tracks: {
            required: false,
            readOnly: true,
            serializedName: 'tracks',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TrackSelectionElementType',
                  type: {
                    name: 'Composite',
                    className: 'TrackSelection'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = StreamingLocatorContentKey;
