/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A disk discovered on a machine.
 *
 */
class Disk {
  /**
   * Create a Disk.
   * @member {number} [gigabytesAllocated] Gigabytes of storage provisioned for
   * this disk.
   * @member {number} [gigabytesConsumed] Gigabytes of storage consumed by this
   * disk.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Disk
   *
   * @returns {object} metadata of Disk
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Disk',
      type: {
        name: 'Composite',
        className: 'Disk',
        modelProperties: {
          gigabytesAllocated: {
            required: false,
            readOnly: true,
            serializedName: 'gigabytesAllocated',
            type: {
              name: 'Number'
            }
          },
          gigabytesConsumed: {
            required: false,
            readOnly: true,
            serializedName: 'gigabytesConsumed',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Disk;
