/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure action group
 *
 */
class AzNsActionGroup {
  /**
   * Create a AzNsActionGroup.
   * @property {array} [actionGroup] Azure Action Group reference.
   * @property {string} [emailSubject] Custom subject override for all email
   * ids in Azure action group
   * @property {string} [customWebhookPayload] Custom payload to be sent for
   * all webhook URI in Azure action group
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzNsActionGroup
   *
   * @returns {object} metadata of AzNsActionGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzNsActionGroup',
      type: {
        name: 'Composite',
        className: 'AzNsActionGroup',
        modelProperties: {
          actionGroup: {
            required: false,
            serializedName: 'actionGroup',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          emailSubject: {
            required: false,
            serializedName: 'emailSubject',
            type: {
              name: 'String'
            }
          },
          customWebhookPayload: {
            required: false,
            serializedName: 'customWebhookPayload',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzNsActionGroup;
