/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An Itsm receiver.
 *
 */
class ItsmReceiver {
  /**
   * Create a ItsmReceiver.
   * @property {string} name The name of the Itsm receiver. Names must be
   * unique across all receivers within an action group.
   * @property {string} workspaceId OMS LA instance identifier.
   * @property {string} connectionId Unique identification of ITSM connection
   * among multiple defined in above workspace.
   * @property {string} ticketConfiguration JSON blob for the configurations of
   * the ITSM action. CreateMultipleWorkItems option will be part of this blob
   * as well.
   * @property {string} region Region in which workspace resides. Supported
   * values:'centralindia','japaneast','southeastasia','australiasoutheast','uksouth','westcentralus','canadacentral','eastus','westeurope'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ItsmReceiver
   *
   * @returns {object} metadata of ItsmReceiver
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ItsmReceiver',
      type: {
        name: 'Composite',
        className: 'ItsmReceiver',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          workspaceId: {
            required: true,
            serializedName: 'workspaceId',
            type: {
              name: 'String'
            }
          },
          connectionId: {
            required: true,
            serializedName: 'connectionId',
            type: {
              name: 'String'
            }
          },
          ticketConfiguration: {
            required: true,
            serializedName: 'ticketConfiguration',
            type: {
              name: 'String'
            }
          },
          region: {
            required: true,
            serializedName: 'region',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ItsmReceiver;
