/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * List of available operations.
 *
 */
class OperationsListResults {
  /**
   * Create a OperationsListResults.
   * @property {number} [odatacount] OData entity count; represents the number
   * of operations returned.
   * @property {array} [value] List of available operations.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationsListResults
   *
   * @returns {object} metadata of OperationsListResults
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationsListResults',
      type: {
        name: 'Composite',
        className: 'OperationsListResults',
        modelProperties: {
          odatacount: {
            required: false,
            serializedName: '@odata\\.count',
            constraints: {
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'OperationElementType',
                  type: {
                    name: 'Composite',
                    className: 'Operation'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OperationsListResults;
