/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Query results.
 *
 */
class PolicyStatesQueryResults {
  /**
   * Create a PolicyStatesQueryResults.
   * @property {string} [odatacontext] OData context string; used by OData
   * clients to resolve type information based on metadata.
   * @property {number} [odatacount] OData entity count; represents the number
   * of policy state records returned.
   * @property {array} [value] Query results.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PolicyStatesQueryResults
   *
   * @returns {object} metadata of PolicyStatesQueryResults
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PolicyStatesQueryResults',
      type: {
        name: 'Composite',
        className: 'PolicyStatesQueryResults',
        modelProperties: {
          odatacontext: {
            required: false,
            serializedName: '@odata\\.context',
            type: {
              name: 'String'
            }
          },
          odatacount: {
            required: false,
            serializedName: '@odata\\.count',
            constraints: {
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PolicyStateElementType',
                  type: {
                    name: 'Composite',
                    additionalProperties: {
                      type: {
                        name: 'Dictionary',
                        value: {
                            required: false,
                            serializedName: 'ObjectElementType',
                            type: {
                              name: 'Object'
                            }
                        }
                      }
                    },
                    className: 'PolicyState'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PolicyStatesQueryResults;
