/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents the SKU name and Azure pricing tier for PowerBI Dedicated
 * resource.
 *
 */
class ResourceSku {
  /**
   * Create a ResourceSku.
   * @member {string} name Name of the SKU level.
   * @member {string} [tier] The name of the Azure pricing tier to which the
   * SKU applies. Possible values include: 'PBIE_Azure'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSku
   *
   * @returns {object} metadata of ResourceSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSku',
      type: {
        name: 'Composite',
        className: 'ResourceSku',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            serializedName: 'tier',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSku;
