/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure backup goal feature specific request.
 *
 * @extends models['FeatureSupportRequest']
 */
class AzureBackupGoalFeatureSupportRequest extends models['FeatureSupportRequest'] {
  /**
   * Create a AzureBackupGoalFeatureSupportRequest.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureBackupGoalFeatureSupportRequest
   *
   * @returns {object} metadata of AzureBackupGoalFeatureSupportRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureBackupGoals',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'featureType',
          clientName: 'featureType'
        },
        uberParent: 'FeatureSupportRequest',
        className: 'AzureBackupGoalFeatureSupportRequest',
        modelProperties: {
          featureType: {
            required: true,
            serializedName: 'featureType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureBackupGoalFeatureSupportRequest;
