/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure File Share workload specific backup copy.
 *
 * @extends models['RecoveryPoint']
 */
class AzureFileShareRecoveryPoint extends models['RecoveryPoint'] {
  /**
   * Create a AzureFileShareRecoveryPoint.
   * @member {string} [recoveryPointType] Type of the backup copy. Specifies
   * whether it is a crash consistent backup or app consistent.
   * @member {date} [recoveryPointTime] Time at which this backup copy was
   * created.
   * @member {string} [fileShareSnapshotUri] Contains Url to the snapshot of
   * fileshare, if applicable
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureFileShareRecoveryPoint
   *
   * @returns {object} metadata of AzureFileShareRecoveryPoint
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureFileShareRecoveryPoint',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'objectType',
          clientName: 'objectType'
        },
        uberParent: 'RecoveryPoint',
        className: 'AzureFileShareRecoveryPoint',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          recoveryPointType: {
            required: false,
            serializedName: 'recoveryPointType',
            type: {
              name: 'String'
            }
          },
          recoveryPointTime: {
            required: false,
            serializedName: 'recoveryPointTime',
            type: {
              name: 'DateTime'
            }
          },
          fileShareSnapshotUri: {
            required: false,
            serializedName: 'fileShareSnapshotUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureFileShareRecoveryPoint;
