/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Container for SQL workloads under SQL Availability Group.
 *
 * @extends models['AzureWorkloadContainer']
 */
class AzureSQLAGWorkloadContainerProtectionContainer extends models['AzureWorkloadContainer'] {
  /**
   * Create a AzureSQLAGWorkloadContainerProtectionContainer.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureSQLAGWorkloadContainerProtectionContainer
   *
   * @returns {object} metadata of AzureSQLAGWorkloadContainerProtectionContainer
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SQLAGWorkLoadContainer',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'containerType',
          clientName: 'containerType'
        },
        uberParent: 'ProtectionContainer',
        className: 'AzureSQLAGWorkloadContainerProtectionContainer',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          registrationStatus: {
            required: false,
            serializedName: 'registrationStatus',
            type: {
              name: 'String'
            }
          },
          healthStatus: {
            required: false,
            serializedName: 'healthStatus',
            type: {
              name: 'String'
            }
          },
          containerType: {
            required: true,
            serializedName: 'containerType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          sourceResourceId: {
            required: false,
            serializedName: 'sourceResourceId',
            type: {
              name: 'String'
            }
          },
          lastUpdatedTime: {
            required: false,
            serializedName: 'lastUpdatedTime',
            type: {
              name: 'DateTime'
            }
          },
          extendedInfo: {
            required: false,
            serializedName: 'extendedInfo',
            type: {
              name: 'Composite',
              className: 'AzureWorkloadContainerExtendedInfo'
            }
          },
          workloadType: {
            required: false,
            serializedName: 'workloadType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureSQLAGWorkloadContainerProtectionContainer;
