/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * AzureResource(IaaS VM) Specific feature support request
 *
 * @extends models['FeatureSupportRequest']
 */
class AzureVMResourceFeatureSupportRequest extends models['FeatureSupportRequest'] {
  /**
   * Create a AzureVMResourceFeatureSupportRequest.
   * @member {string} [vmSize] Size of the resource: VM size(A/D series etc) in
   * case of IaasVM
   * @member {string} [vmSku] SKUs (Premium/Managed etc) in case of IaasVM
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureVMResourceFeatureSupportRequest
   *
   * @returns {object} metadata of AzureVMResourceFeatureSupportRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureVMResourceBackup',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'featureType',
          clientName: 'featureType'
        },
        uberParent: 'FeatureSupportRequest',
        className: 'AzureVMResourceFeatureSupportRequest',
        modelProperties: {
          featureType: {
            required: true,
            serializedName: 'featureType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          vmSize: {
            required: false,
            serializedName: 'vmSize',
            type: {
              name: 'String'
            }
          },
          vmSku: {
            required: false,
            serializedName: 'vmSku',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureVMResourceFeatureSupportRequest;
