/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure VM workload-specific additional information for job.
 *
 */
class AzureWorkloadJobExtendedInfo {
  /**
   * Create a AzureWorkloadJobExtendedInfo.
   * @member {array} [tasksList] List of tasks for this job
   * @member {object} [propertyBag] Job properties.
   * @member {string} [dynamicErrorMessage] Non localized error message on job
   * execution.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureWorkloadJobExtendedInfo
   *
   * @returns {object} metadata of AzureWorkloadJobExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureWorkloadJobExtendedInfo',
      type: {
        name: 'Composite',
        className: 'AzureWorkloadJobExtendedInfo',
        modelProperties: {
          tasksList: {
            required: false,
            serializedName: 'tasksList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AzureWorkloadJobTaskDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'AzureWorkloadJobTaskDetails'
                  }
              }
            }
          },
          propertyBag: {
            required: false,
            serializedName: 'propertyBag',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          dynamicErrorMessage: {
            required: false,
            serializedName: 'dynamicErrorMessage',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureWorkloadJobExtendedInfo;
