/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * AzureWorkload SAP Hana -specific restore. Specifically for PointInTime/Log
 * restore
 *
 * @extends models['AzureWorkloadSAPHanaRestoreRequest']
 */
class AzureWorkloadSAPHanaPointInTimeRestoreRequest extends models['AzureWorkloadSAPHanaRestoreRequest'] {
  /**
   * Create a AzureWorkloadSAPHanaPointInTimeRestoreRequest.
   * @member {date} [pointInTime] PointInTime value
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureWorkloadSAPHanaPointInTimeRestoreRequest
   *
   * @returns {object} metadata of AzureWorkloadSAPHanaPointInTimeRestoreRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureWorkloadSAPHanaPointInTimeRestoreRequest',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'objectType',
          clientName: 'objectType'
        },
        uberParent: 'RestoreRequest',
        className: 'AzureWorkloadSAPHanaPointInTimeRestoreRequest',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          targetInfo: {
            required: false,
            serializedName: 'targetInfo',
            type: {
              name: 'Composite',
              className: 'TargetRestoreInfo'
            }
          },
          recoveryType: {
            required: false,
            serializedName: 'recoveryType',
            type: {
              name: 'String'
            }
          },
          sourceResourceId: {
            required: false,
            serializedName: 'sourceResourceId',
            type: {
              name: 'String'
            }
          },
          propertyBag: {
            required: false,
            serializedName: 'propertyBag',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          pointInTime: {
            required: false,
            serializedName: 'pointInTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureWorkloadSAPHanaPointInTimeRestoreRequest;
