/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure Workload SQL Auto Protection intent item.
 *
 * @extends models['AzureWorkloadAutoProtectionIntent']
 */
class AzureWorkloadSQLAutoProtectionIntent extends models['AzureWorkloadAutoProtectionIntent'] {
  /**
   * Create a AzureWorkloadSQLAutoProtectionIntent.
   * @member {string} [workloadItemType] Workload item type of the item for
   * which intent is to be set. Possible values include: 'Invalid',
   * 'SQLInstance', 'SQLDataBase', 'SAPHanaSystem', 'SAPHanaDatabase'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureWorkloadSQLAutoProtectionIntent
   *
   * @returns {object} metadata of AzureWorkloadSQLAutoProtectionIntent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureWorkloadSQLAutoProtectionIntent',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'protectionIntentItemType',
          clientName: 'protectionIntentItemType'
        },
        uberParent: 'ProtectionIntent',
        className: 'AzureWorkloadSQLAutoProtectionIntent',
        modelProperties: {
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          sourceResourceId: {
            required: false,
            serializedName: 'sourceResourceId',
            type: {
              name: 'String'
            }
          },
          itemId: {
            required: false,
            serializedName: 'itemId',
            type: {
              name: 'String'
            }
          },
          policyId: {
            required: false,
            serializedName: 'policyId',
            type: {
              name: 'String'
            }
          },
          protectionState: {
            required: false,
            serializedName: 'protectionState',
            type: {
              name: 'String'
            }
          },
          protectionIntentItemType: {
            required: true,
            serializedName: 'protectionIntentItemType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          workloadItemType: {
            required: false,
            serializedName: 'workloadItemType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureWorkloadSQLAutoProtectionIntent;
