/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Filters to list items that can be backed up.
 *
 */
class BMSWorkloadItemQueryObject {
  /**
   * Create a BMSWorkloadItemQueryObject.
   * @member {string} [backupManagementType] Backup management type. Possible
   * values include: 'Invalid', 'AzureIaasVM', 'MAB', 'DPM',
   * 'AzureBackupServer', 'AzureSql', 'AzureStorage', 'AzureWorkload',
   * 'DefaultBackup'
   * @member {string} [workloadItemType] Workload Item type. Possible values
   * include: 'Invalid', 'SQLInstance', 'SQLDataBase', 'SAPHanaSystem',
   * 'SAPHanaDatabase'
   * @member {string} [workloadType] Workload type. Possible values include:
   * 'Invalid', 'VM', 'FileFolder', 'AzureSqlDb', 'SQLDB', 'Exchange',
   * 'Sharepoint', 'VMwareVM', 'SystemState', 'Client', 'GenericDataSource',
   * 'SQLDataBase', 'AzureFileShare', 'SAPHanaDatabase'
   * @member {string} [protectionStatus] Backup status query parameter.
   * Possible values include: 'Invalid', 'NotProtected', 'Protecting',
   * 'Protected', 'ProtectionFailed'
   */
  constructor() {
  }

  /**
   * Defines the metadata of BMSWorkloadItemQueryObject
   *
   * @returns {object} metadata of BMSWorkloadItemQueryObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BMSWorkloadItemQueryObject',
      type: {
        name: 'Composite',
        className: 'BMSWorkloadItemQueryObject',
        modelProperties: {
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          workloadItemType: {
            required: false,
            serializedName: 'workloadItemType',
            type: {
              name: 'String'
            }
          },
          workloadType: {
            required: false,
            serializedName: 'workloadType',
            type: {
              name: 'String'
            }
          },
          protectionStatus: {
            required: false,
            serializedName: 'protectionStatus',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BMSWorkloadItemQueryObject;
