/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Response for check name availability API. Resource provider will set
 * availability as true | false.
 *
 * @extends models['Resource']
 */
class CheckNameAvailabilityResultResource extends models['Resource'] {
  /**
   * Create a CheckNameAvailabilityResultResource.
   * @property {object} [properties] CheckNameAvailabilityResultResource
   * properties
   * @property {boolean} [properties.nameAvailable]
   * @property {string} [properties.reason]
   * @property {string} [properties.message]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CheckNameAvailabilityResultResource
   *
   * @returns {object} metadata of CheckNameAvailabilityResultResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CheckNameAvailabilityResultResource',
      type: {
        name: 'Composite',
        className: 'CheckNameAvailabilityResultResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          eTag: {
            required: false,
            serializedName: 'eTag',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'CheckNameAvailabilityResult'
            }
          }
        }
      }
    };
  }
}

module.exports = CheckNameAvailabilityResultResource;
