/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A2A provider specific recovery point details.
 *
 * @extends models['ProviderSpecificRecoveryPointDetails']
 */
class A2ARecoveryPointDetails extends models['ProviderSpecificRecoveryPointDetails'] {
  /**
   * Create a A2ARecoveryPointDetails.
   * @member {string} [recoveryPointSyncType] A value indicating whether the
   * recovery point is multi VM consistent. Possible values include:
   * 'MultiVmSyncRecoveryPoint', 'PerVmRecoveryPoint'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of A2ARecoveryPointDetails
   *
   * @returns {object} metadata of A2ARecoveryPointDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'A2A',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'instanceType',
          clientName: 'instanceType'
        },
        uberParent: 'ProviderSpecificRecoveryPointDetails',
        className: 'A2ARecoveryPointDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          recoveryPointSyncType: {
            required: false,
            serializedName: 'recoveryPointSyncType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = A2ARecoveryPointDetails;
