/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Response to put/get patch schedules for Redis cache.
 *
 * @extends models['ProxyResource']
 */
class RedisPatchSchedule extends models['ProxyResource'] {
  /**
   * Create a RedisPatchSchedule.
   * @property {array} scheduleEntries List of patch schedules for a Redis
   * cache.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RedisPatchSchedule
   *
   * @returns {object} metadata of RedisPatchSchedule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RedisPatchSchedule',
      type: {
        name: 'Composite',
        className: 'RedisPatchSchedule',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          scheduleEntries: {
            required: true,
            serializedName: 'properties.scheduleEntries',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ScheduleEntryElementType',
                  type: {
                    name: 'Composite',
                    className: 'ScheduleEntry'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RedisPatchSchedule;
