/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AppliedReservations.
 */
class AppliedReservations {
  /**
   * Create a AppliedReservations.
   * @property {string} [id] Identifier of the applied reservations
   * @property {string} [name] Name of resource
   * @property {string} [type] Type of resource.
   * "Microsoft.Capacity/AppliedReservations"
   * @property {object} [reservationOrderIds]
   * @property {array} [reservationOrderIds.value]
   * @property {string} [reservationOrderIds.nextLink] Url to get the next page
   * of reservations
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppliedReservations
   *
   * @returns {object} metadata of AppliedReservations
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppliedReservations',
      type: {
        name: 'Composite',
        className: 'AppliedReservations',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          reservationOrderIds: {
            required: false,
            serializedName: 'properties.reservationOrderIds',
            type: {
              name: 'Composite',
              className: 'AppliedReservationList'
            }
          }
        }
      }
    };
  }
}

module.exports = AppliedReservations;
