/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a Patch.
 */
class Patch {
  /**
   * Create a Patch.
   * @property {string} [appliedScopeType] Possible values include: 'Single',
   * 'Shared'
   * @property {array} [appliedScopes]
   * @property {string} [instanceFlexibility] Possible values include: 'On',
   * 'Off'
   * @property {string} [name] Name of the Reservation
   */
  constructor() {
  }

  /**
   * Defines the metadata of Patch
   *
   * @returns {object} metadata of Patch
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Patch',
      type: {
        name: 'Composite',
        className: 'Patch',
        modelProperties: {
          appliedScopeType: {
            required: false,
            serializedName: 'properties.appliedScopeType',
            type: {
              name: 'String'
            }
          },
          appliedScopes: {
            required: false,
            serializedName: 'properties.appliedScopes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          instanceFlexibility: {
            required: false,
            serializedName: 'properties.instanceFlexibility',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'properties.name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Patch;
