/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */

import { BaseResource, CloudError } from "ms-rest-azure";

export {

  BaseResource,
  CloudError
};

/**
 * Resource link filter.
 */
export interface ResourceLinkFilter {
  /**
   * The ID of the target resource.
   */
  targetId: string;
}

/**
 * The resource link properties.
 */
export interface ResourceLinkProperties {
  /**
   * The fully qualified ID of the source resource in the link.
   */
  readonly sourceId?: string;
  /**
   * The fully qualified ID of the target resource in the link.
   */
  targetId: string;
  /**
   * Notes about the resource link.
   */
  notes?: string;
}

/**
 * The resource link.
 */
export interface ResourceLink extends BaseResource {
  /**
   * The fully qualified ID of the resource link.
   */
  readonly id?: string;
  /**
   * The name of the resource link.
   */
  readonly name?: string;
  /**
   * The resource link object.
   */
  readonly type?: any;
  /**
   * Properties for resource link.
   */
  properties?: ResourceLinkProperties;
}

/**
 * The object that represents the operation.
 */
export interface OperationDisplay {
  /**
   * Service provider: Microsoft.Resources
   */
  provider?: string;
  /**
   * Resource on which the operation is performed: Profile, endpoint, etc.
   */
  resource?: string;
  /**
   * Operation type: Read, write, delete, etc.
   */
  operation?: string;
  /**
   * Description of the operation.
   */
  description?: string;
}

/**
 * Microsoft.Resources operation
 */
export interface Operation {
  /**
   * Operation name: {provider}/{resource}/{operation}
   */
  name?: string;
  /**
   * The object that represents the operation.
   */
  display?: OperationDisplay;
}

/**
 * Result of the request to list Microsoft.Resources operations. It contains a list of operations
 * and a URL link to get the next set of results.
 */
export interface OperationListResult extends Array<Operation> {
  /**
   * URL to get the next set of operation list results if there are any.
   */
  nextLink?: string;
}

/**
 * List of resource links.
 */
export interface ResourceLinkResult extends Array<ResourceLink> {
  /**
   * The URL to use for getting the next set of results.
   */
  readonly nextLink?: string;
}
