/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Tag information.
 *
 * @extends models['BaseResource']
 */
class TagValue extends models['BaseResource'] {
  /**
   * Create a TagValue.
   * @property {string} [id] The tag ID.
   * @property {string} [tagValue] The tag value.
   * @property {object} [count] The tag value count.
   * @property {string} [count.type] Type of count.
   * @property {number} [count.value] Value of count.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TagValue
   *
   * @returns {object} metadata of TagValue
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TagValue',
      type: {
        name: 'Composite',
        className: 'TagValue',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          tagValue: {
            required: false,
            serializedName: 'tagValue',
            type: {
              name: 'String'
            }
          },
          count: {
            required: false,
            serializedName: 'count',
            type: {
              name: 'Composite',
              className: 'TagCount'
            }
          }
        }
      }
    };
  }
}

module.exports = TagValue;
