/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents an AAD identity protection solution which sends logs to an OMS
 * workspace.
 *
 * @extends models['ExternalSecuritySolution']
 */
class AadExternalSecuritySolution extends models['ExternalSecuritySolution'] {
  /**
   * Create a AadExternalSecuritySolution.
   * @member {object} [properties]
   * @member {string} [properties.deviceVendor]
   * @member {string} [properties.deviceType]
   * @member {object} [properties.workspace]
   * @member {string} [properties.workspace.id] Azure resource ID of the
   * connected OMS workspace
   * @member {string} [properties.connectivityState] Possible values include:
   * 'Discovered', 'NotLicensed', 'Connected'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AadExternalSecuritySolution
   *
   * @returns {object} metadata of AadExternalSecuritySolution
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AAD',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'ExternalSecuritySolution',
        className: 'AadExternalSecuritySolution',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'AadSolutionProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = AadExternalSecuritySolution;
