/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary The external security solution properties for AAD solutions
  *
 */
class AadSolutionProperties {
  /**
   * Create a AadSolutionProperties.
   * @member {string} [deviceVendor]
   * @member {string} [deviceType]
   * @member {object} [workspace]
   * @member {string} [workspace.id] Azure resource ID of the connected OMS
   * workspace
   * @member {string} [connectivityState] The connectivity state of the
   * external AAD solution . Possible values include: 'Discovered',
   * 'NotLicensed', 'Connected'
   */
  constructor() {
  }

  /**
   * Defines the metadata of AadSolutionProperties
   *
   * @returns {object} metadata of AadSolutionProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AadSolutionProperties',
      type: {
        name: 'Composite',
        className: 'AadSolutionProperties',
        modelProperties: {
          deviceVendor: {
            required: false,
            serializedName: 'deviceVendor',
            type: {
              name: 'String'
            }
          },
          deviceType: {
            required: false,
            serializedName: 'deviceType',
            type: {
              name: 'String'
            }
          },
          workspace: {
            required: false,
            serializedName: 'workspace',
            type: {
              name: 'Composite',
              className: 'ConnectedWorkspace'
            }
          },
          connectivityState: {
            required: false,
            serializedName: 'connectivityState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AadSolutionProperties;
