/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the allowed inbound and outbound traffic of an Azure resource
 *
 */
class ConnectableResource {
  /**
   * Create a ConnectableResource.
   * @member {string} [id] The Azure resource id
   * @member {array} [inboundConnectedResources] The list of Azure resources
   * that the resource has inbound allowed connection from
   * @member {array} [outboundConnectedResources] The list of Azure resources
   * that the resource has outbound allowed connection to
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConnectableResource
   *
   * @returns {object} metadata of ConnectableResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnectableResource',
      type: {
        name: 'Composite',
        className: 'ConnectableResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          inboundConnectedResources: {
            required: false,
            readOnly: true,
            serializedName: 'inboundConnectedResources',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ConnectedResourceElementType',
                  type: {
                    name: 'Composite',
                    className: 'ConnectedResource'
                  }
              }
            }
          },
          outboundConnectedResources: {
            required: false,
            readOnly: true,
            serializedName: 'outboundConnectedResources',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ConnectedResourceElementType',
                  type: {
                    name: 'Composite',
                    className: 'ConnectedResource'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ConnectableResource;
