/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Chaos Remove Replica Fault Completed event.
 *
 * @extends models['ReplicaEvent']
 */
class ChaosRemoveReplicaFaultCompletedEvent extends models['ReplicaEvent'] {
  /**
   * Create a ChaosRemoveReplicaFaultCompletedEvent.
   * @property {uuid} faultGroupId Id of fault group.
   * @property {uuid} faultId Id of fault.
   * @property {string} serviceUri Service name.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ChaosRemoveReplicaFaultCompletedEvent
   *
   * @returns {object} metadata of ChaosRemoveReplicaFaultCompletedEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ChaosRemoveReplicaFaultCompleted',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'ChaosRemoveReplicaFaultCompletedEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          partitionId: {
            required: true,
            serializedName: 'PartitionId',
            type: {
              name: 'String'
            }
          },
          replicaId: {
            required: true,
            serializedName: 'ReplicaId',
            type: {
              name: 'Number'
            }
          },
          faultGroupId: {
            required: true,
            serializedName: 'FaultGroupId',
            type: {
              name: 'String'
            }
          },
          faultId: {
            required: true,
            serializedName: 'FaultId',
            type: {
              name: 'String'
            }
          },
          serviceUri: {
            required: true,
            serializedName: 'ServiceUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ChaosRemoveReplicaFaultCompletedEvent;
