/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Cluster Upgrade Complete event.
 *
 * @extends models['ClusterEvent']
 */
class ClusterUpgradeCompleteEvent extends models['ClusterEvent'] {
  /**
   * Create a ClusterUpgradeCompleteEvent.
   * @property {string} targetClusterVersion Target Cluster version.
   * @property {number} overallUpgradeElapsedTimeInMs Overall duration of
   * upgrade in milli-seconds.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ClusterUpgradeCompleteEvent
   *
   * @returns {object} metadata of ClusterUpgradeCompleteEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterUpgradeComplete',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'ClusterUpgradeCompleteEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          targetClusterVersion: {
            required: true,
            serializedName: 'TargetClusterVersion',
            type: {
              name: 'String'
            }
          },
          overallUpgradeElapsedTimeInMs: {
            required: true,
            serializedName: 'OverallUpgradeElapsedTimeInMs',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterUpgradeCompleteEvent;
