/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * parameters for making container API call.
 *
 */
class ContainerApiRequestBody {
  /**
   * Create a ContainerApiRequestBody.
   * @property {string} [httpVerb] HTTP verb of container REST API, defaults to
   * "GET"
   * @property {string} uriPath URI path of container REST API
   * @property {string} [contentType] Content type of container REST API
   * request, defaults to "application/json"
   * @property {string} [body] HTTP request body of container REST API
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerApiRequestBody
   *
   * @returns {object} metadata of ContainerApiRequestBody
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerApiRequestBody',
      type: {
        name: 'Composite',
        className: 'ContainerApiRequestBody',
        modelProperties: {
          httpVerb: {
            required: false,
            serializedName: 'HttpVerb',
            type: {
              name: 'String'
            }
          },
          uriPath: {
            required: true,
            serializedName: 'UriPath',
            type: {
              name: 'String'
            }
          },
          contentType: {
            required: false,
            serializedName: 'Content-Type',
            type: {
              name: 'String'
            }
          },
          body: {
            required: false,
            serializedName: 'Body',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerApiRequestBody;
