/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A paged list of Service Fabric names. The list is paged when all of the
 * results cannot fit in a single message. The next set of results can be
 * obtained by executing the same query with the continuation token provided in
 * this list.
 *
 */
class PagedSubNameInfoList {
  /**
   * Create a PagedSubNameInfoList.
   * @property {string} [continuationToken] The continuation token parameter is
   * used to obtain next set of results. The continuation token is included in
   * the response of the API when the results from the system do not fit in a
   * single response. When this value is passed to the next API call, the API
   * returns next set of results. If there are no further results, then the
   * continuation token is not included in the response.
   * @property {boolean} [isConsistent] Indicates whether any name under the
   * given name has been modified during the enumeration. If there was a
   * modification, this property value is false.
   * @property {array} [subNames] List of the child names.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PagedSubNameInfoList
   *
   * @returns {object} metadata of PagedSubNameInfoList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PagedSubNameInfoList',
      type: {
        name: 'Composite',
        className: 'PagedSubNameInfoList',
        modelProperties: {
          continuationToken: {
            required: false,
            serializedName: 'ContinuationToken',
            type: {
              name: 'String'
            }
          },
          isConsistent: {
            required: false,
            serializedName: 'IsConsistent',
            type: {
              name: 'Boolean'
            }
          },
          subNames: {
            required: false,
            serializedName: 'SubNames',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PagedSubNameInfoList;
