/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a list of property batch operations to be executed. Either all or
 * none of the operations will be committed.
 *
 */
class PropertyBatchDescriptionList {
  /**
   * Create a PropertyBatchDescriptionList.
   * @property {array} [operations] A list of the property batch operations to
   * be executed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PropertyBatchDescriptionList
   *
   * @returns {object} metadata of PropertyBatchDescriptionList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PropertyBatchDescriptionList',
      type: {
        name: 'Composite',
        className: 'PropertyBatchDescriptionList',
        modelProperties: {
          operations: {
            required: false,
            serializedName: 'Operations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PropertyBatchOperationElementType',
                  type: {
                    name: 'Composite',
                    polymorphicDiscriminator: {
                      serializedName: 'Kind',
                      clientName: 'kind'
                    },
                    uberParent: 'PropertyBatchOperation',
                    className: 'PropertyBatchOperation'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PropertyBatchDescriptionList;
