/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Identifies the Service Fabric stateful service which is being backed up.
 *
 * @extends models['BackupEntity']
 */
class ServiceBackupEntity extends models['BackupEntity'] {
  /**
   * Create a ServiceBackupEntity.
   * @property {string} [serviceName] The full name of the service with
   * 'fabric:' URI scheme.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceBackupEntity
   *
   * @returns {object} metadata of ServiceBackupEntity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Service',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'EntityKind',
          clientName: 'entityKind'
        },
        uberParent: 'BackupEntity',
        className: 'ServiceBackupEntity',
        modelProperties: {
          entityKind: {
            required: true,
            serializedName: 'EntityKind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          serviceName: {
            required: false,
            serializedName: 'ServiceName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceBackupEntity;
