/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes parameters for creating application-scoped volumes provided by
 * Service Fabric Volume Disks
 *
 * @extends models['ApplicationScopedVolumeCreationParameters']
 */
class ApplicationScopedVolumeCreationParametersServiceFabricVolumeDisk extends models['ApplicationScopedVolumeCreationParameters'] {
  /**
   * Create a ApplicationScopedVolumeCreationParametersServiceFabricVolumeDisk.
   * @member {string} sizeDisk Volume size. Possible values include: 'Small',
   * 'Medium', 'Large'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ApplicationScopedVolumeCreationParametersServiceFabricVolumeDisk
   *
   * @returns {object} metadata of ApplicationScopedVolumeCreationParametersServiceFabricVolumeDisk
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceFabricVolumeDisk',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'ApplicationScopedVolumeCreationParameters',
        className: 'ApplicationScopedVolumeCreationParametersServiceFabricVolumeDisk',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          sizeDisk: {
            required: true,
            serializedName: 'sizeDisk',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationScopedVolumeCreationParametersServiceFabricVolumeDisk;
