/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the VM image of a machine.
 *
 */
class ImageConfiguration {
  /**
   * Create a ImageConfiguration.
   * @member {string} [publisher] Publisher of the VM image.
   * @member {string} [offering] Offering of the VM image.
   * @member {string} [sku] SKU of the VM image.
   * @member {string} [version] Version of the VM image.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageConfiguration
   *
   * @returns {object} metadata of ImageConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageConfiguration',
      type: {
        name: 'Composite',
        className: 'ImageConfiguration',
        modelProperties: {
          publisher: {
            required: false,
            serializedName: 'publisher',
            type: {
              name: 'String'
            }
          },
          offering: {
            required: false,
            serializedName: 'offering',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ImageConfiguration;
