/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Parameters for SignalR service create/update operation.
 *
 * Keep the same schema as AzSignalR.Models.SignalRResource
 *
 * @extends models['SignalRUpdateParameters']
 */
class SignalRCreateParameters extends models['SignalRUpdateParameters'] {
  /**
   * Create a SignalRCreateParameters.
   * @member {string} location Azure GEO region: e.g. West US | East US | North
   * Central US | South Central US | West Europe | North Europe | East Asia |
   * Southeast Asia | etc.
   * The geo region of a resource never changes after it is created.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SignalRCreateParameters
   *
   * @returns {object} metadata of SignalRCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SignalRCreateParameters',
      type: {
        name: 'Composite',
        className: 'SignalRCreateParameters',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'ResourceSku'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'SignalRCreateOrUpdateProperties'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SignalRCreateParameters;
