/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.Resource = require('./resource');
exports.ProxyResource = require('./proxyResource');
exports.RecoverableDatabase = require('./recoverableDatabase');
exports.RestorableDroppedDatabase = require('./restorableDroppedDatabase');
exports.TrackedResource = require('./trackedResource');
exports.CheckNameAvailabilityRequest = require('./checkNameAvailabilityRequest');
exports.CheckNameAvailabilityResponse = require('./checkNameAvailabilityResponse');
exports.ServerConnectionPolicy = require('./serverConnectionPolicy');
exports.DatabaseSecurityAlertPolicy = require('./databaseSecurityAlertPolicy');
exports.DataMaskingPolicy = require('./dataMaskingPolicy');
exports.DataMaskingRule = require('./dataMaskingRule');
exports.FirewallRule = require('./firewallRule');
exports.GeoBackupPolicy = require('./geoBackupPolicy');
exports.ImportExtensionRequest = require('./importExtensionRequest');
exports.ImportExportResponse = require('./importExportResponse');
exports.ExportRequest = require('./exportRequest');
exports.ImportRequest = require('./importRequest');
exports.MetricValue = require('./metricValue');
exports.MetricName = require('./metricName');
exports.Metric = require('./metric');
exports.MetricAvailability = require('./metricAvailability');
exports.MetricDefinition = require('./metricDefinition');
exports.RecommendedElasticPoolMetric = require('./recommendedElasticPoolMetric');
exports.RecommendedElasticPool = require('./recommendedElasticPool');
exports.ReplicationLink = require('./replicationLink');
exports.ServerAzureADAdministrator = require('./serverAzureADAdministrator');
exports.ServerCommunicationLink = require('./serverCommunicationLink');
exports.ServiceObjective = require('./serviceObjective');
exports.ElasticPoolActivity = require('./elasticPoolActivity');
exports.ElasticPoolDatabaseActivity = require('./elasticPoolDatabaseActivity');
exports.OperationImpact = require('./operationImpact');
exports.RecommendedIndex = require('./recommendedIndex');
exports.TransparentDataEncryption = require('./transparentDataEncryption');
exports.SloUsageMetric = require('./sloUsageMetric');
exports.ServiceTierAdvisor = require('./serviceTierAdvisor');
exports.TransparentDataEncryptionActivity = require('./transparentDataEncryptionActivity');
exports.ServerUsage = require('./serverUsage');
exports.DatabaseUsage = require('./databaseUsage');
exports.AutomaticTuningOptions = require('./automaticTuningOptions');
exports.DatabaseAutomaticTuning = require('./databaseAutomaticTuning');
exports.EncryptionProtector = require('./encryptionProtector');
exports.FailoverGroupReadWriteEndpoint = require('./failoverGroupReadWriteEndpoint');
exports.FailoverGroupReadOnlyEndpoint = require('./failoverGroupReadOnlyEndpoint');
exports.PartnerInfo = require('./partnerInfo');
exports.FailoverGroup = require('./failoverGroup');
exports.FailoverGroupUpdate = require('./failoverGroupUpdate');
exports.ResourceIdentity = require('./resourceIdentity');
exports.Sku = require('./sku');
exports.ManagedInstance = require('./managedInstance');
exports.ManagedInstanceUpdate = require('./managedInstanceUpdate');
exports.OperationDisplay = require('./operationDisplay');
exports.Operation = require('./operation');
exports.ServerKey = require('./serverKey');
exports.Server = require('./server');
exports.ServerUpdate = require('./serverUpdate');
exports.SyncAgent = require('./syncAgent');
exports.SyncAgentKeyProperties = require('./syncAgentKeyProperties');
exports.SyncAgentLinkedDatabase = require('./syncAgentLinkedDatabase');
exports.SyncDatabaseIdProperties = require('./syncDatabaseIdProperties');
exports.SyncFullSchemaTableColumn = require('./syncFullSchemaTableColumn');
exports.SyncFullSchemaTable = require('./syncFullSchemaTable');
exports.SyncFullSchemaProperties = require('./syncFullSchemaProperties');
exports.SyncGroupLogProperties = require('./syncGroupLogProperties');
exports.SyncGroupSchemaTableColumn = require('./syncGroupSchemaTableColumn');
exports.SyncGroupSchemaTable = require('./syncGroupSchemaTable');
exports.SyncGroupSchema = require('./syncGroupSchema');
exports.SyncGroup = require('./syncGroup');
exports.SyncMember = require('./syncMember');
exports.SubscriptionUsage = require('./subscriptionUsage');
exports.VirtualCluster = require('./virtualCluster');
exports.VirtualClusterUpdate = require('./virtualClusterUpdate');
exports.VirtualNetworkRule = require('./virtualNetworkRule');
exports.ExtendedDatabaseBlobAuditingPolicy = require('./extendedDatabaseBlobAuditingPolicy');
exports.ExtendedServerBlobAuditingPolicy = require('./extendedServerBlobAuditingPolicy');
exports.ServerBlobAuditingPolicy = require('./serverBlobAuditingPolicy');
exports.DatabaseBlobAuditingPolicy = require('./databaseBlobAuditingPolicy');
exports.DatabaseVulnerabilityAssessmentRuleBaselineItem = require('./databaseVulnerabilityAssessmentRuleBaselineItem');
exports.DatabaseVulnerabilityAssessmentRuleBaseline = require('./databaseVulnerabilityAssessmentRuleBaseline');
exports.VulnerabilityAssessmentRecurringScansProperties = require('./vulnerabilityAssessmentRecurringScansProperties');
exports.DatabaseVulnerabilityAssessment = require('./databaseVulnerabilityAssessment');
exports.JobAgent = require('./jobAgent');
exports.JobAgentUpdate = require('./jobAgentUpdate');
exports.JobCredential = require('./jobCredential');
exports.JobExecutionTarget = require('./jobExecutionTarget');
exports.JobExecution = require('./jobExecution');
exports.JobSchedule = require('./jobSchedule');
exports.Job = require('./job');
exports.JobStepAction = require('./jobStepAction');
exports.JobStepOutput = require('./jobStepOutput');
exports.JobStepExecutionOptions = require('./jobStepExecutionOptions');
exports.JobStep = require('./jobStep');
exports.JobTarget = require('./jobTarget');
exports.JobTargetGroup = require('./jobTargetGroup');
exports.JobVersion = require('./jobVersion');
exports.LongTermRetentionBackup = require('./longTermRetentionBackup');
exports.BackupLongTermRetentionPolicy = require('./backupLongTermRetentionPolicy');
exports.ManagedBackupShortTermRetentionPolicy = require('./managedBackupShortTermRetentionPolicy');
exports.CompleteDatabaseRestoreDefinition = require('./completeDatabaseRestoreDefinition');
exports.ManagedDatabase = require('./managedDatabase');
exports.ManagedDatabaseUpdate = require('./managedDatabaseUpdate');
exports.AutomaticTuningServerOptions = require('./automaticTuningServerOptions');
exports.ServerAutomaticTuning = require('./serverAutomaticTuning');
exports.ServerDnsAlias = require('./serverDnsAlias');
exports.ServerDnsAliasAcquisition = require('./serverDnsAliasAcquisition');
exports.ServerSecurityAlertPolicy = require('./serverSecurityAlertPolicy');
exports.RestorableDroppedManagedDatabase = require('./restorableDroppedManagedDatabase');
exports.RestorePoint = require('./restorePoint');
exports.CreateDatabaseRestorePointDefinition = require('./createDatabaseRestorePointDefinition');
exports.ManagedDatabaseSecurityAlertPolicy = require('./managedDatabaseSecurityAlertPolicy');
exports.ManagedServerSecurityAlertPolicy = require('./managedServerSecurityAlertPolicy');
exports.SensitivityLabel = require('./sensitivityLabel');
exports.DatabaseOperation = require('./databaseOperation');
exports.ElasticPoolOperation = require('./elasticPoolOperation');
exports.MaxSizeCapability = require('./maxSizeCapability');
exports.LogSizeCapability = require('./logSizeCapability');
exports.MaxSizeRangeCapability = require('./maxSizeRangeCapability');
exports.PerformanceLevelCapability = require('./performanceLevelCapability');
exports.LicenseTypeCapability = require('./licenseTypeCapability');
exports.ServiceObjectiveCapability = require('./serviceObjectiveCapability');
exports.EditionCapability = require('./editionCapability');
exports.ElasticPoolPerDatabaseMinPerformanceLevelCapability = require('./elasticPoolPerDatabaseMinPerformanceLevelCapability');
exports.ElasticPoolPerDatabaseMaxPerformanceLevelCapability = require('./elasticPoolPerDatabaseMaxPerformanceLevelCapability');
exports.ElasticPoolPerformanceLevelCapability = require('./elasticPoolPerformanceLevelCapability');
exports.ElasticPoolEditionCapability = require('./elasticPoolEditionCapability');
exports.ServerVersionCapability = require('./serverVersionCapability');
exports.ManagedInstanceVcoresCapability = require('./managedInstanceVcoresCapability');
exports.ManagedInstanceFamilyCapability = require('./managedInstanceFamilyCapability');
exports.ManagedInstanceEditionCapability = require('./managedInstanceEditionCapability');
exports.ManagedInstanceVersionCapability = require('./managedInstanceVersionCapability');
exports.LocationCapabilities = require('./locationCapabilities');
exports.Database = require('./database');
exports.DatabaseUpdate = require('./databaseUpdate');
exports.ResourceMoveDefinition = require('./resourceMoveDefinition');
exports.ElasticPoolPerDatabaseSettings = require('./elasticPoolPerDatabaseSettings');
exports.ElasticPool = require('./elasticPool');
exports.ElasticPoolUpdate = require('./elasticPoolUpdate');
exports.VulnerabilityAssessmentScanError = require('./vulnerabilityAssessmentScanError');
exports.VulnerabilityAssessmentScanRecord = require('./vulnerabilityAssessmentScanRecord');
exports.DatabaseVulnerabilityAssessmentScansExport = require('./databaseVulnerabilityAssessmentScansExport');
exports.InstanceFailoverGroupReadWriteEndpoint = require('./instanceFailoverGroupReadWriteEndpoint');
exports.InstanceFailoverGroupReadOnlyEndpoint = require('./instanceFailoverGroupReadOnlyEndpoint');
exports.PartnerRegionInfo = require('./partnerRegionInfo');
exports.ManagedInstancePairInfo = require('./managedInstancePairInfo');
exports.InstanceFailoverGroup = require('./instanceFailoverGroup');
exports.BackupShortTermRetentionPolicy = require('./backupShortTermRetentionPolicy');
exports.TdeCertificate = require('./tdeCertificate');
exports.ManagedInstanceKey = require('./managedInstanceKey');
exports.ManagedInstanceEncryptionProtector = require('./managedInstanceEncryptionProtector');
exports.RecoverableManagedDatabase = require('./recoverableManagedDatabase');
exports.ManagedInstanceVulnerabilityAssessment = require('./managedInstanceVulnerabilityAssessment');
exports.ServerVulnerabilityAssessment = require('./serverVulnerabilityAssessment');
exports.RecoverableDatabaseListResult = require('./recoverableDatabaseListResult');
exports.RestorableDroppedDatabaseListResult = require('./restorableDroppedDatabaseListResult');
exports.ServerListResult = require('./serverListResult');
exports.DataMaskingRuleListResult = require('./dataMaskingRuleListResult');
exports.FirewallRuleListResult = require('./firewallRuleListResult');
exports.GeoBackupPolicyListResult = require('./geoBackupPolicyListResult');
exports.MetricListResult = require('./metricListResult');
exports.MetricDefinitionListResult = require('./metricDefinitionListResult');
exports.DatabaseListResult = require('./databaseListResult');
exports.ElasticPoolListResult = require('./elasticPoolListResult');
exports.RecommendedElasticPoolListResult = require('./recommendedElasticPoolListResult');
exports.RecommendedElasticPoolListMetricsResult = require('./recommendedElasticPoolListMetricsResult');
exports.ReplicationLinkListResult = require('./replicationLinkListResult');
exports.ServerAdministratorListResult = require('./serverAdministratorListResult');
exports.ServerCommunicationLinkListResult = require('./serverCommunicationLinkListResult');
exports.ServiceObjectiveListResult = require('./serviceObjectiveListResult');
exports.ElasticPoolActivityListResult = require('./elasticPoolActivityListResult');
exports.ElasticPoolDatabaseActivityListResult = require('./elasticPoolDatabaseActivityListResult');
exports.ServiceTierAdvisorListResult = require('./serviceTierAdvisorListResult');
exports.TransparentDataEncryptionActivityListResult = require('./transparentDataEncryptionActivityListResult');
exports.ServerUsageListResult = require('./serverUsageListResult');
exports.DatabaseUsageListResult = require('./databaseUsageListResult');
exports.EncryptionProtectorListResult = require('./encryptionProtectorListResult');
exports.FailoverGroupListResult = require('./failoverGroupListResult');
exports.ManagedInstanceListResult = require('./managedInstanceListResult');
exports.OperationListResult = require('./operationListResult');
exports.ServerKeyListResult = require('./serverKeyListResult');
exports.SyncAgentListResult = require('./syncAgentListResult');
exports.SyncAgentLinkedDatabaseListResult = require('./syncAgentLinkedDatabaseListResult');
exports.SyncDatabaseIdListResult = require('./syncDatabaseIdListResult');
exports.SyncFullSchemaPropertiesListResult = require('./syncFullSchemaPropertiesListResult');
exports.SyncGroupLogListResult = require('./syncGroupLogListResult');
exports.SyncGroupListResult = require('./syncGroupListResult');
exports.SyncMemberListResult = require('./syncMemberListResult');
exports.SubscriptionUsageListResult = require('./subscriptionUsageListResult');
exports.VirtualClusterListResult = require('./virtualClusterListResult');
exports.VirtualNetworkRuleListResult = require('./virtualNetworkRuleListResult');
exports.DatabaseVulnerabilityAssessmentListResult = require('./databaseVulnerabilityAssessmentListResult');
exports.JobAgentListResult = require('./jobAgentListResult');
exports.JobCredentialListResult = require('./jobCredentialListResult');
exports.JobExecutionListResult = require('./jobExecutionListResult');
exports.JobListResult = require('./jobListResult');
exports.JobStepListResult = require('./jobStepListResult');
exports.JobTargetGroupListResult = require('./jobTargetGroupListResult');
exports.JobVersionListResult = require('./jobVersionListResult');
exports.LongTermRetentionBackupListResult = require('./longTermRetentionBackupListResult');
exports.ManagedBackupShortTermRetentionPolicyListResult = require('./managedBackupShortTermRetentionPolicyListResult');
exports.ManagedDatabaseListResult = require('./managedDatabaseListResult');
exports.ServerDnsAliasListResult = require('./serverDnsAliasListResult');
exports.LogicalServerSecurityAlertPolicyListResult = require('./logicalServerSecurityAlertPolicyListResult');
exports.RestorableDroppedManagedDatabaseListResult = require('./restorableDroppedManagedDatabaseListResult');
exports.RestorePointListResult = require('./restorePointListResult');
exports.ManagedDatabaseSecurityAlertPolicyListResult = require('./managedDatabaseSecurityAlertPolicyListResult');
exports.ManagedServerSecurityAlertPolicyListResult = require('./managedServerSecurityAlertPolicyListResult');
exports.SensitivityLabelListResult = require('./sensitivityLabelListResult');
exports.DatabaseOperationListResult = require('./databaseOperationListResult');
exports.ElasticPoolOperationListResult = require('./elasticPoolOperationListResult');
exports.VulnerabilityAssessmentScanRecordListResult = require('./vulnerabilityAssessmentScanRecordListResult');
exports.InstanceFailoverGroupListResult = require('./instanceFailoverGroupListResult');
exports.BackupShortTermRetentionPolicyListResult = require('./backupShortTermRetentionPolicyListResult');
exports.ManagedInstanceKeyListResult = require('./managedInstanceKeyListResult');
exports.ManagedInstanceEncryptionProtectorListResult = require('./managedInstanceEncryptionProtectorListResult');
exports.RecoverableManagedDatabaseListResult = require('./recoverableManagedDatabaseListResult');
exports.ManagedInstanceVulnerabilityAssessmentListResult = require('./managedInstanceVulnerabilityAssessmentListResult');
exports.ServerVulnerabilityAssessmentListResult = require('./serverVulnerabilityAssessmentListResult');
