/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

exports.RecoverableDatabases = require('./recoverableDatabases');
exports.RestorableDroppedDatabases = require('./restorableDroppedDatabases');
exports.Servers = require('./servers');
exports.ServerConnectionPolicies = require('./serverConnectionPolicies');
exports.DatabaseThreatDetectionPolicies = require('./databaseThreatDetectionPolicies');
exports.DataMaskingPolicies = require('./dataMaskingPolicies');
exports.DataMaskingRules = require('./dataMaskingRules');
exports.FirewallRules = require('./firewallRules');
exports.GeoBackupPolicies = require('./geoBackupPolicies');
exports.Databases = require('./databases');
exports.ElasticPools = require('./elasticPools');
exports.RecommendedElasticPools = require('./recommendedElasticPools');
exports.ReplicationLinks = require('./replicationLinks');
exports.ServerAzureADAdministrators = require('./serverAzureADAdministrators');
exports.ServerCommunicationLinks = require('./serverCommunicationLinks');
exports.ServiceObjectives = require('./serviceObjectives');
exports.ElasticPoolActivities = require('./elasticPoolActivities');
exports.ElasticPoolDatabaseActivities = require('./elasticPoolDatabaseActivities');
exports.ServiceTierAdvisors = require('./serviceTierAdvisors');
exports.TransparentDataEncryptions = require('./transparentDataEncryptions');
exports.TransparentDataEncryptionActivities = require('./transparentDataEncryptionActivities');
exports.ServerUsages = require('./serverUsages');
exports.DatabaseUsages = require('./databaseUsages');
exports.DatabaseAutomaticTuningOperations = require('./databaseAutomaticTuningOperations');
exports.EncryptionProtectors = require('./encryptionProtectors');
exports.FailoverGroups = require('./failoverGroups');
exports.ManagedInstances = require('./managedInstances');
exports.Operations = require('./operations');
exports.ServerKeys = require('./serverKeys');
exports.SyncAgents = require('./syncAgents');
exports.SyncGroups = require('./syncGroups');
exports.SyncMembers = require('./syncMembers');
exports.SubscriptionUsages = require('./subscriptionUsages');
exports.VirtualClusters = require('./virtualClusters');
exports.VirtualNetworkRules = require('./virtualNetworkRules');
exports.ExtendedDatabaseBlobAuditingPolicies = require('./extendedDatabaseBlobAuditingPolicies');
exports.ExtendedServerBlobAuditingPolicies = require('./extendedServerBlobAuditingPolicies');
exports.ServerBlobAuditingPolicies = require('./serverBlobAuditingPolicies');
exports.DatabaseBlobAuditingPolicies = require('./databaseBlobAuditingPolicies');
exports.DatabaseVulnerabilityAssessmentRuleBaselines = require('./databaseVulnerabilityAssessmentRuleBaselines');
exports.DatabaseVulnerabilityAssessments = require('./databaseVulnerabilityAssessments');
exports.JobAgents = require('./jobAgents');
exports.JobCredentials = require('./jobCredentials');
exports.JobExecutions = require('./jobExecutions');
exports.Jobs = require('./jobs');
exports.JobStepExecutions = require('./jobStepExecutions');
exports.JobSteps = require('./jobSteps');
exports.JobTargetExecutions = require('./jobTargetExecutions');
exports.JobTargetGroups = require('./jobTargetGroups');
exports.JobVersions = require('./jobVersions');
exports.LongTermRetentionBackups = require('./longTermRetentionBackups');
exports.BackupLongTermRetentionPolicies = require('./backupLongTermRetentionPolicies');
exports.ManagedBackupShortTermRetentionPolicies = require('./managedBackupShortTermRetentionPolicies');
exports.ManagedDatabases = require('./managedDatabases');
exports.ManagedRestorableDroppedDatabaseBackupShortTermRetentionPolicies = require('./managedRestorableDroppedDatabaseBackupShortTermRetentionPolicies');
exports.ServerAutomaticTuningOperations = require('./serverAutomaticTuningOperations');
exports.ServerDnsAliases = require('./serverDnsAliases');
exports.ServerSecurityAlertPolicies = require('./serverSecurityAlertPolicies');
exports.RestorableDroppedManagedDatabases = require('./restorableDroppedManagedDatabases');
exports.RestorePoints = require('./restorePoints');
exports.ManagedDatabaseSecurityAlertPolicies = require('./managedDatabaseSecurityAlertPolicies');
exports.ManagedServerSecurityAlertPolicies = require('./managedServerSecurityAlertPolicies');
exports.SensitivityLabels = require('./sensitivityLabels');
exports.DatabaseOperations = require('./databaseOperations');
exports.ElasticPoolOperations = require('./elasticPoolOperations');
exports.Capabilities = require('./capabilities');
exports.DatabaseVulnerabilityAssessmentScans = require('./databaseVulnerabilityAssessmentScans');
exports.ManagedDatabaseVulnerabilityAssessmentRuleBaselines = require('./managedDatabaseVulnerabilityAssessmentRuleBaselines');
exports.ManagedDatabaseVulnerabilityAssessmentScans = require('./managedDatabaseVulnerabilityAssessmentScans');
exports.ManagedDatabaseVulnerabilityAssessments = require('./managedDatabaseVulnerabilityAssessments');
exports.InstanceFailoverGroups = require('./instanceFailoverGroups');
exports.BackupShortTermRetentionPolicies = require('./backupShortTermRetentionPolicies');
exports.TdeCertificates = require('./tdeCertificates');
exports.ManagedInstanceTdeCertificates = require('./managedInstanceTdeCertificates');
exports.ManagedInstanceKeys = require('./managedInstanceKeys');
exports.ManagedInstanceEncryptionProtectors = require('./managedInstanceEncryptionProtectors');
exports.RecoverableManagedDatabases = require('./recoverableManagedDatabases');
exports.ManagedInstanceVulnerabilityAssessments = require('./managedInstanceVulnerabilityAssessments');
exports.ServerVulnerabilityAssessments = require('./serverVulnerabilityAssessments');
exports.ManagedDatabaseSensitivityLabels = require('./managedDatabaseSensitivityLabels');
