/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class represents BackupElement
 *
 * @extends models['BaseModel']
 */
class BackupElement extends models['BaseModel'] {
  /**
   * Create a BackupElement.
   * @member {number} sizeInBytes The size in bytes.
   * @member {string} endpointName The name of the endpoint.
   * @member {string} dataPolicy The data policy of backed up endpoint.
   * Possible values include: 'Invalid', 'Local', 'Tiered', 'Cloud'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BackupElement
   *
   * @returns {object} metadata of BackupElement
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupElement',
      type: {
        name: 'Composite',
        className: 'BackupElement',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          sizeInBytes: {
            required: true,
            serializedName: 'properties.sizeInBytes',
            type: {
              name: 'Number'
            }
          },
          endpointName: {
            required: true,
            serializedName: 'properties.endpointName',
            type: {
              name: 'String'
            }
          },
          dataPolicy: {
            required: true,
            serializedName: 'properties.dataPolicy',
            type: {
              name: 'Enum',
              allowedValues: [ 'Invalid', 'Local', 'Tiered', 'Cloud' ]
            }
          }
        }
      }
    };
  }
}

module.exports = BackupElement;
