/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Metric availability specifies the time grain (aggregation interval or
 * frequency) and the retention period for that time grain
 *
 */
class MetricAvailablity {
  /**
   * Create a MetricAvailablity.
   * @member {string} timeGrain The time grain, specifies the aggregation
   * interval for the metric.
   * @member {string} retention The retention period for the metric at the
   * specified timegrain
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetricAvailablity
   *
   * @returns {object} metadata of MetricAvailablity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetricAvailablity',
      type: {
        name: 'Composite',
        className: 'MetricAvailablity',
        modelProperties: {
          timeGrain: {
            required: true,
            serializedName: 'timeGrain',
            type: {
              name: 'String'
            }
          },
          retention: {
            required: true,
            serializedName: 'retention',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MetricAvailablity;
