/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The NetworkSettings of a device
 *
 * @extends models['BaseModel']
 */
class NetworkSettings extends models['BaseModel'] {
  /**
   * Create a NetworkSettings.
   * @member {string} primaryDnsServer The Primary DNS server for the device
   * @member {string} [secondaryDnsServer] The secondary DNS server for the
   * device
   * @member {array} nodeNetworks The NetworkAdapters under each node of the
   * device.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of NetworkSettings
   *
   * @returns {object} metadata of NetworkSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkSettings',
      type: {
        name: 'Composite',
        className: 'NetworkSettings',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          primaryDnsServer: {
            required: true,
            serializedName: 'properties.primaryDnsServer',
            type: {
              name: 'String'
            }
          },
          secondaryDnsServer: {
            required: false,
            serializedName: 'properties.secondaryDnsServer',
            type: {
              name: 'String'
            }
          },
          nodeNetworks: {
            required: true,
            serializedName: 'properties.nodeNetworks',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NodeNetworkElementType',
                  type: {
                    name: 'Composite',
                    className: 'NodeNetwork'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkSettings;
