/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This class can be used as the Type for any secret entity represented as
 * Value, ValueCertificateThumbprint, EncryptionAlgorithm. In this case,
 * "Value" is a secret and the "valueThumbprint" represents the certificate
 * thumbprint of the value. The algorithm field is mainly for future usage to
 * potentially allow different entities encrypted using different algorithms.
 *
 */
class SymmetricEncryptedSecret {
  /**
   * Create a SymmetricEncryptedSecret.
   * @member {string} value The value of the secret itself. If the secret is in
   * plaintext or null then EncryptionAlgorithm will be none
   * @member {string} [valueCertificateThumbprint] Thumbprint cert that was
   * used to encrypt "Value"
   * @member {string} encryptionAlgorithm Algorithm used to encrypt "Value".
   * Possible values include: 'None', 'AES256', 'RSAES_PKCS1_v_1_5'
   */
  constructor() {
  }

  /**
   * Defines the metadata of SymmetricEncryptedSecret
   *
   * @returns {object} metadata of SymmetricEncryptedSecret
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SymmetricEncryptedSecret',
      type: {
        name: 'Composite',
        className: 'SymmetricEncryptedSecret',
        modelProperties: {
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          valueCertificateThumbprint: {
            required: false,
            serializedName: 'valueCertificateThumbprint',
            type: {
              name: 'String'
            }
          },
          encryptionAlgorithm: {
            required: true,
            serializedName: 'encryptionAlgorithm',
            type: {
              name: 'Enum',
              allowedValues: [ 'None', 'AES256', 'RSAES_PKCS1_v_1_5' ]
            }
          }
        }
      }
    };
  }
}

module.exports = SymmetricEncryptedSecret;
