/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Cloud Endpoint object.
 *
 * @extends models['ProxyResource']
 */
class CloudEndpoint extends models['ProxyResource'] {
  /**
   * Create a CloudEndpoint.
   * @property {string} [storageAccountResourceId] Storage Account Resource Id
   * @property {string} [azureFileShareName] Azure file share name
   * @property {string} [storageAccountTenantId] Storage Account Tenant Id
   * @property {string} [partnershipId] Partnership Id
   * @property {string} [friendlyName] Friendly Name
   * @property {string} [backupEnabled] Backup Enabled
   * @property {string} [provisioningState] CloudEndpoint Provisioning State
   * @property {string} [lastWorkflowId] CloudEndpoint lastWorkflowId
   * @property {string} [lastOperationName] Resource Last Operation Name
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CloudEndpoint
   *
   * @returns {object} metadata of CloudEndpoint
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CloudEndpoint',
      type: {
        name: 'Composite',
        className: 'CloudEndpoint',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          storageAccountResourceId: {
            required: false,
            serializedName: 'properties.storageAccountResourceId',
            type: {
              name: 'String'
            }
          },
          azureFileShareName: {
            required: false,
            serializedName: 'properties.azureFileShareName',
            type: {
              name: 'String'
            }
          },
          storageAccountTenantId: {
            required: false,
            serializedName: 'properties.storageAccountTenantId',
            type: {
              name: 'String'
            }
          },
          partnershipId: {
            required: false,
            serializedName: 'properties.partnershipId',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'properties.friendlyName',
            type: {
              name: 'String'
            }
          },
          backupEnabled: {
            required: false,
            readOnly: true,
            serializedName: 'properties.backupEnabled',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          lastWorkflowId: {
            required: false,
            serializedName: 'properties.lastWorkflowId',
            type: {
              name: 'String'
            }
          },
          lastOperationName: {
            required: false,
            serializedName: 'properties.lastOperationName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CloudEndpoint;
