/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Sync Group object.
 *
 * @extends models['ProxyResource']
 */
class SyncGroup extends models['ProxyResource'] {
  /**
   * Create a SyncGroup.
   * @property {string} [uniqueId] Unique Id
   * @property {string} [syncGroupStatus] Sync group status
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SyncGroup
   *
   * @returns {object} metadata of SyncGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SyncGroup',
      type: {
        name: 'Composite',
        className: 'SyncGroup',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          uniqueId: {
            required: false,
            serializedName: 'properties.uniqueId',
            type: {
              name: 'String'
            }
          },
          syncGroupStatus: {
            required: false,
            readOnly: true,
            serializedName: 'properties.syncGroupStatus',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SyncGroup;
