/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A key-value object consisting of filters that may be specified to limit the
 * results returned by the API. Current available filters: site.
 *
 */
class Filters {
  /**
   * Create a Filters.
   * @property {string} [site] The URL of the site to return similar images and
   * similar products from. (e.g., "www.bing.com", "bing.com").
   */
  constructor() {
  }

  /**
   * Defines the metadata of Filters
   *
   * @returns {object} metadata of Filters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Filters',
      type: {
        name: 'Composite',
        className: 'Filters',
        modelProperties: {
          site: {
            required: false,
            serializedName: 'site',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Filters;
